              $NODEBUG
              $GEN
;
;
;
;
;
;  iCARD v2.02  (c) 1995 DSH
;
;  !! Betriebssystem fr EPROM 27C256 !!
;
;
;ͻ
; P 3.0  - RxD <-> V.24 CARD DATA    P 3.5 - T1 N.C.                  
; P 3.1  - TxD <-> V.24 CARD DATA                                     
; P 3.2  - INT0 <-> V.24             P 1.5 - SDA                      
; P 3.3  - INT1 <-> CARD RESET       P 1.6 - SCL                      
; P 3.4  - T0 SWITCH                 P 1.7 - SYNC                     
;ͼ
;
;
;
;
EEPROM        EQU 10101110B                 ; GERTEADRESSE EEPROM 24C65
;                                           ; BIT1-3 = A0-2 AM EEPROM
BASIS         EQU 0000H                     ; EPROM-START
RAMSTART      EQU 8000H                     ; EXTERNES RAM
;
SKYTAB        EQU RAMSTART + 1800H          ; INTERNE KARTENTABELLE (256)
SKYKEYS1      EQU RAMSTART + 1900H          ; AKTUELLE KEYS #1 FR 09ER KARTEN (128)
SKYKEYS2      EQU RAMSTART + 1980H          ; AKTUELLE KEYS #2 FR 09ER KARTEN (128)
ADULTKEYS     EQU RAMSTART + 1A00H          ; KEYS FR 07ER KARTEN (256)
OSD           EQU RAMSTART + 1B00H          ; OSD/BLDSCHIRMMELDUNG (25)
EXTPROG       EQU RAMSTART + 1D00H          ; EXT. PROGRAMM FR OSD-VERARBEITUNG
;
NANOBUFFER    EQU RAMSTART + 1FA0H          ; BUFFER FR HASHFUNKTION 9FA0-9FBF (32)
BUFFER        EQU RAMSTART + 1FC0H          ; BYTEPUFFER 9FC0-9FFF (64)
;
DELAYATR      EQU 4BD3H                     ; ANSWER-TO-RESET WARTEZEIT CA. 50mS
V24DELAY      EQU 99H                       ; 'BYTE SENDEN' WARTEZEIT CA. 500uS
MAXOSD        EQU 8                         ; ZHLER FR OSD-MELDUNG
FIXEDBAUD     EQU 0FAH                      ; TIMERWERT FR BAUDRATE (9600BPS)
MAXTIMER      EQU 1                         ; ANZAHL TIMER-BERLUFE BIS ATR (0=1)
;
;
;
;             1 PORTZUWEISUNGEN
;             -----------------
;
SDA           BIT P1.5                      ; DATENLEITUNG IC
SCL           BIT P1.6                      ; TAKTLEITUNG IC
ENABLE        BIT P3.4                      ; SCHALTER
GLED          BIT P1.0                      ; LED, GRN
RLED          BIT P1.1                      ; LED, ROT
RXDATA        BIT P3.0                      ; RXD-PIN
TXDATA        BIT P3.1                      ; TXD-PIN
RST           BIT P3.3                      ; RESET-PIN
;
;
;
;             2 INTERNES BIT-ORIENTIERTES RAM
;             -------------------------------
;
BUSFAULT      BIT 00H                       ; "BUS FAULT" (IC)
I2CBUSY       BIT 01H                       ; "BUSY FLAG" (IC)
EEPROMFLAG    BIT 02H                       ; "EEPROM VORHANDEN"
INVERT        BIT 03H                       ; "INVERTIERT SENDEN/EMPFANGEN"
NOACK         BIT 04H                       ; "KEIN ACK EMPFANGEN" (IC)
DATAFLAG      BIT 05H                       ; "DATEN EINGELESEN"
CODEFLAG      BIT 06H                       ; "CODES GENERIEREN"
READYFLAG     BIT 07H                       ; "HAUPTPROGRAMM IST BEREIT"
OSDFLAG       BIT 08H                       ; "OSD DAUERHAFT ANZEIGEN"
RANDOMFLAG    BIT 09H                       ; "EEPROM GELESEN"
NOFIT         BIT 0AH                       ; "HASH-FEHLER"
SKYFLAG       BIT 0BH                       ; "BSKYB-MULTICHANNEL"
NEVERFLAG     BIT 0CH                       ; "OSD NIE ANZEIGEN"
ADULTFLAG     BIT 0DH                       ; "ADULT CHANNEL"
ANSWERONE     BIT 0EH                       ; "1.BYTE ANSWER = 01"
BREAKFLAG     BIT 0FH                       ; "BREAKFLAG FR NANOCOMMAND"
EXECFLAG      BIT 10H                       ; "DECODE IM XRAM AUSFHREN"
IDFLAG        BIT 11H                       ; "CHANNEL-ID NICHT ANZEIGEN"
TABFLAG       BIT 12H                       ; "FLAG FR NANOCOMMAND *30*"
NANOFLAG      BIT 13H                       ; "EXECUTE NANOCOMAND"
IDEXT         BIT 14H                       ; "EXT. PROG. AUSFHREN"
INT0FLAG      BIT 15H                       ; "INT0 (RESTART) ENABLE"
INT1FLAG      BIT 16H                       ; "INT1 (RESTART) ENABLE"
ERRORFLAG     BIT 17H                       ; "KEY-FEHLER"
DEBUGFLAG     BIT 18H                       ; "TEST MODE ENABLED"
SCANFLAG      BIT 19H                       ; "KEYSCANNING ENABLED"
ANSWERFLAG    BIT 1AH                       ; "ANTWORTPUFFER FERTIG"
;
;
;
;             3 INTERNES BYTE-ORIENTIERTES RAM
;             --------------------------------
;
ANSWER        DATA 10H                      ; PUFFER (-17, 8 BYTES)
EEPROM_MSB    DATA 18H                      ; EEPROM-ADRESSE MSB A8-A12
EEPROM_LSB    DATA 19H                      ; EEPROM-ADRESSE LSB A0-A7
COUNT         DATA 1AH                      ; ZHLER FR INSTRUCTION
PRECOUNT      DATA 1BH                      ; ZWISCHENSPEICHER FR ZHLER
INSCOUNT      DATA 1CH                      ; ANZAHL BYTES
BDELAY        DATA 1DH                      ; BYTEWAIT-ZEIT
INSBYTE       DATA 1EH                      ; INSTRUCTIONCODE
BYTE          DATA 1FH                      ; AKTUELLES BYTE
POINTER       DATA 24H                      ; ZEIGER IN PUFFER
OSDCOUNT      DATA 25H                      ; ZHLER FR OSD
XCOUNT        DATA 26H                      ; ZHLER FR EXTERNES RAM
CHANNELID     DATA 27H                      ; KANAL-IDENTIFIKATION
ATRDELAYL     DATA 28H                      ; TIMER 0 - BERLAUF LSB
ATRDELAYM     DATA 29H                      ; TIMER 0 - BERLAUF MSB
CHECKSUM      DATA 2AH                      ; ZW.SPEICHER FR PRFSUMMEN
COUNTER       DATA 2BH                      ; TEMP. BENUTZUNG
OPTION1       DATA 2CH                      ; EXTERNE FLAGS #1
OPTION2       DATA 2DH                      ; EXTERNE FLAGS #2
BAUDRATE      DATA 2EH                      ; AKT. BAUDRATE
TABFLAGS      DATA 2FH                      ; FLAGS FR TABELLEN
SUBADRLSB     DATA 30H                      ; ADRESS-SPEICHER LSB
SUBADRMSB     DATA 31H                      ; ADRESS-SPEICHER MSB
ADRESSLSB     DATA 32H                      ; ADRESS-SPEICHER LSB
ADRESSMSB     DATA 33H                      ; ADRESS-SPEICHER MSB
ANDMASK       DATA 34H                      ; AND-MASKE FR KEYS
XORMASK       DATA 35H                      ; XOR-MASKE FR KEYS
TIMERCNT      DATA 36H                      ; ANZAHL TIMER-BERLUFE
CODEPNT       DATA 37H                      ; ZEIGER IN CODE-PUFFER
TEMP1         DATA 38H                      ; TEMP. ZW.SPEICHER FR DECODE
TEMP2         DATA 39H                      ; TEMP. ZW.SPEICHER FR DECODE
FITCOUNT      DATA 3AH                      ; TEMP. ZHLER FR FEHLER
KEYINDEX      DATA 3BH                      ; INDEX IN KEYTABELLE
LASTCOUNT     DATA 3CH                      ; ZW.SPEICHER F. ZHLER
;
CODES         DATA 40H                      ; KEYPUFFER (-5F, 32 BYTES)
;
;
;
;
              ORG  BASIS
;
              JMP  STARTUP
;
;
;
              ORG  BASIS+0003H              ; EXTERNER INTERRUPT 0
;
              JMP  STARTUP
;
;
;
              ORG  BASIS+000BH              ; INTERUPT TIMER 0
;
              JMP  DO_T0INT
;
;
;
              ORG  BASIS+0013H              ; EXTERNER INTERRUPT 1
;
              JMP  STARTUP
;
;
;
              ORG  BASIS+0023H              ; SERIELLE SCHNITTSTELLE
;
              JMP  DO_V24INT
;
;
;
TABLE:        JMP  GETCLA                   ; COUNT=00
              JMP  GETINS                   ; COUNT=01
              JMP  GETPX                    ; COUNT=02
              JMP  GETPX                    ; COUNT=03
              JMP  GETP3                    ; COUNT=04
;
              JMP  INS70                    ; COUNT=05
              JMP  INS72                    ; COUNT=06
              JMP  INS74                    ; COUNT=07
              JMP  INS76                    ; COUNT=08
              JMP  INS78                    ; COUNT=09
              JMP  INS7A                    ; COUNT=10
              JMP  INS7C                    ; COUNT=11
              JMP  INS7E                    ; COUNT=12
              JMP  INS80                    ; COUNT=13
              JMP  INS82                    ; COUNT=14
;
              JMP  STOREX                   ; COUNT=15
              JMP  STOREI1                  ; COUNT=16
              JMP  STOREI2                  ; COUNT=17
              JMP  STOREI3                  ; COUNT=18
              JMP  STOREI4                  ; COUNT=19
;
;
;
STARTUP:      CLR  EA                       ; VORSICHTSHALBER INTS SPERREN
              MOV  SP,#60H                  ; STACK VON 60-7F (32 BYTES)
              MOV  PSW,#0                   ; STATUS LSCHEN
              MOV  P1,#11100011B            ; PORTBITS INIT.
              MOV  P3,#11111111B
              CALL INIT_SFR                 ; SPECIAL FUNCTION REGISTER INIT.
              CALL INIT_IRAM                ; INT. RAM LSCHEN
              SETB TXDATA                   ; TXD-PIN = 1
              SETB RXDATA                   ; RXD-PIN = 1
              SETB EA                       ; INTS EIN
              CLR  RLED                     ; ROTE LED EIN
              SETB GLED                     ; GRNE LED AUS
              CLR  ET0                      ; T0-INT AUS
              CLR  TR0                      ; T0 STOPPP
              MOV  TL0,ATRDELAYL            ; BERLAUFRATE LSB
              MOV  TH0,ATRDELAYM            ; BERLAUFRATE MSB
              SETB ET0                      ; T0-INT ENABLE
              SETB TR0                      ; TIMER 0 START !
              JNB  EEPROMFLAG,NOREAD        ; EEPROM VORHANDEN ?
              CALL RCVXRAM                  ; DANN EEPROM LESEN
              JNC  TABSREAD                 ; FEHLER?
NOREAD:       CLR  EXECFLAG                 ; JA, DANN FLAG LSCHEN
              MOV  TABFLAGS,#0              ; TAB-FLAGS LSCHEN
TABSREAD:     CALL COPYTABS                 ; TABELLEN ROM->RAM
              SETB READYFLAG                ; HAUPTPROGRAMM FERTIG !
MAINLOOP:     JNB  ENABLE,DISABLE           ; SCHALTER AUF ENABLE ?
              JNB  CODEFLAG,MAINLOOP        ; 74ER PAKET ?, NEIN, DANN WARTEN
              CLR  RLED                     ; ROTE LED EIN
              JNB  EXECFLAG,DOSKY           ; ROM-DECODE AUSFHREN ?
              CALL RAMSTART                 ; NEIN, DANN EXT. PROGRAMM
              JMP  HASHEXIT                 ; UND BEENDEN
;
;
;
DISABLE:      CLR  EA                       ; INTERRUPTS AUS
              SETB RLED
              SETB GLED                     ; LEDS AUS
SCANV24:      MOV  C,RXDATA                 ; DATENLEITUNG
              MOV  GLED,C                   ; AUF GRNE LED
              MOV  C,RST                    ; UND RESET-PIN AUF
              MOV  RLED,C                   ; ROTE LED SCHALTEN
              JNB  ENABLE,SCANV24           ; WARTEN ....
              JMP  STARTUP                  ; DANN NEUSTART !
;
;
;
DOSKY:        MOV  A,CODES
              JNB  ACC.3,NOCHANNEL          ; BIT 3 IM ERSTEN BYTE GESETZT ?
              MOV  A,CODES+6                ; DANN CHANNEL-ID LESEN
              MOV  CHANNELID,A              ; UND ERSTMAL SICHERN
NOCHANNEL:    CLR  NOFIT
              MOV  R5,#0
              MOV  R0,#CODES+27
              MOV  R7,#4
KERNELOOP:    MOV  A,R5
              CALL NEWHASH                  ; -> KERNEL
              MOV  A,R5
              CALL NEWHASH                  ; -> KERNEL
              MOV  A,@R0
              MOV  R5,A
              MOV  A,ANSWER+7
              XRL  A,R5                     ; SIGNATUR PRFEN
              JZ   SIGNOK                   ; OKAY ?
              SETB NOFIT                    ; NEIN, DANN FEHLERFLAG SETZEN
SIGNOK:       INC  R0
              DJNZ R7,KERNELOOP
              MOV  A,#90H                   ; SW1 = 90
              CALL SENDTHRU                 ; AN DEKODER
              JB   NOFIT,NONINE
              JNB  NANOFLAG,NONINE
              MOV  R0,#CODES+16
              MOV  DPTR,#NANOBUFFER
              MOV  R2,#16
              CALL COPY_ROM
              MOV  A,#0                     ; SW2 = 00
              CALL SENDTHRU                 ; AN DEKODER (ALLES KLAR!)
              JMP  ITSNINE
;
;
;
NONINE:       CLR  A
              CALL SENDV24
              JB   NOFIT,TRYADULT           ; DECODE-FEHLER ?, DANN ADULT TESTEN
ITSNINE:      SETB SKYFLAG                  ; 09ER - CODE !
              CLR  ADULTFLAG                ; 07ER-FLAG LSCHEN
              CLR  ERRORFLAG                ; FEHLERFLAG LSCHEN
              CLR  SCANFLAG                 ; KEYSCANNER AUS
              MOV  FITCOUNT,#0              ; FEHLERZHLER = 0
              MOV  A,CODES+31               ; SCHLEIFENZHLER LADEN
              MOV  R5,A                     ; UND SICHERN
              JB   NANOFLAG,NANOCODE        ; NANO-COMMAND ?
LASTHASH:     MOV  R7,#64                   ; NEIN, DANN LETZTEN HASH 64-MAL
FIFTHASH:     MOV  A,R5                     ; MIT SCHLEIFENZHLER
              CALL NEWHASH                  ; -> KERNEL
              DJNZ R7,FIFTHASH              ; UND WEITER ...
              JMP  HASHEXIT                 ; BEENDEN
;
;
;
TRYADULT:     JMP  DOADULT                  ; 07ER-KEYS TESTEN
;
;
;
NANOCODE:     CLR  BREAKFLAG                ; BREAK-FLAG LSCHEN
              CLR  TABFLAG
              MOV  R0,#CODES+16             ; ZEIGER AUF NANO-TABELLE
NANOPARSE:    MOV  A,@R0
              INC  R0
              CJNE A,#011H,NONANO11         ; NANO-COMMAND = 11H ?
              MOV  A,@R0                    ; BYTE SICHERN
              MOV  B,A
              MOV  A,R0
              MOV  R1,A
              INC  R1
              MOV  A,@R1                    ; MSB DER ADRESSE LADEN
              JNZ  ENDNANO11                ; <> 0, DANN  ENDE
              INC  R1
              MOV  A,@R1                    ; LSB DER ADRESSE LADEN
              MOV  R1,A
              XRL  A,#0AAH                  ; ADRESSE 00AAH ?
              JZ   ITS00AA
              XRL  A,#2BH                   ; ADRESSE = 0081 ?
              JNZ  ENDNANO11
              MOV  A,B
              ANL  A,#0B7H                  ; JA, DANN BYTE AND B7
              ADD  A,#40H                   ; UND 40H DAZUADDIEREN (SEHR WITZIG!)
              MOV  B,A
ITS00AA:      MOV  DPTR,#SKYTAB             ; ZEIGER IN KARTENTABELLE
              MOV  A,DPL
              ADD  A,R1
              MOV  DPL,A                    ; + ADRESSE
              JNC  NOMSB
              INC  DPH
NOMSB:        MOV  A,B
              MOVX @DPTR,A                  ; BYTEWERT IN TABELLE SCHREIBEN
ENDNANO11:    INC  R0
              INC  R0                       ; OFFSET KORRIGIEREN
              INC  R0
              JMP  EXITNANO                 ; UND WEITER
;
;
;
NONANO11:     CJNE A,#09H,NONANO09          ; NANO-COMMAND = 09h ?
              MOV  A,@R0                    ; ADRESS-MSB LADEN
              MOV  SUBADRMSB,A              ; UND SICHERN
              INC  R0
              MOV  A,@R0                    ; ADRESS-LSB LADEN
              MOV  SUBADRLSB,A              ; UND SICHERN
              INC  R0
              MOV  A,R0
              MOV  R1,A
              MOV  A,@R1
              XRL  A,#30H                   ; FOLGT NANO 30H ?
              JNZ  NOPE30
              INC  R1
              MOV  A,@R1
              ADD  A,SUBADRLSB
              MOV  ADRESSLSB,A              ; JA, DANN ADRESSEN GENERIEREN
              MOV  A,SUBADRMSB
              ADDC A,#0
              MOV  ADRESSMSB,A
              ANL  A,#1FH
              JZ   NOPE30
              SETB TABFLAG
              MOV  A,ADRESSLSB
              XRL  A,#0FFH
              ADD  A,#LOW  ROMIMAGE
              MOV  ADRESSLSB,A
              MOV  A,ADRESSMSB
              XRL  A,#0FH
              ADDC A,#HIGH ROMIMAGE
              MOV  ADRESSMSB,A
NOPE30:       MOV  A,#63H
              CALL NEWHASH                  ; -> KERNEL MIT 63H
              CLR  A
              JMP  ONCEHASH                 ; -> KERNEL MIT 00H
;
;
;
NONANO09:     CJNE A,#30H,NONANO30          ; NANO-COMMAND = 30H ?
              MOV  A,@R0                    ; INDEX & ZHLER LADEN
              MOV  R7,A                     ; UND SICHERN
              INC  R0
              JB   TABFLAG,READIMAGE        ; AUS ROMIMAGE LESEN ?
              MOV  DPTR,#SKYTAB
INNERLOOP:    MOV  A,ADRESSLSB
              MOVC A,@A+DPTR
              MOV  R1,A
              CALL NEWHASH
              DEC  ADRESSLSB
              MOV  A,R7
              DJNZ R7,COUNTDN1
COUNTDN1:     JB   ACC.7,NEGATIVE
              JNZ  INNERLOOP
NEGATIVE:     MOV  A,R1
              CALL NEWHASH                  ; -> KERNEL MIT KARTENBYTE
              MOV  A,R7
              JMP  ONCEHASH                 ; -> KERNEL MIT ZHLER (-1)
;
;
;
READIMAGE:    MOV  DPL,ADRESSLSB
              MOV  DPH,ADRESSMSB
OUTERLOOP:    MOVX A,@DPTR                  ; BYTE AUS KARTENROM LESEN
              INC  DPTR
              MOV  R1,A                     ; UND SICHERN
              CALL NEWHASH                  ; -> KERNEL MIT KARTENBYTE
              MOV  A,R7                     ; ZHLER LADEN
              DJNZ R7,COUNTDN2              ; ZHLER - 1
COUNTDN2:     JB   ACC.7,NEGATIVE           ; ZHLER NEGATIV ?, DANN ENDE
              JNZ  OUTERLOOP                ; ZHLER <> 0, DANN SCHLEIFE
              MOV  A,R1
              CALL NEWHASH                  ; -> KERNEL MIT KARTENBYTE
              MOV  A,R7
              JMP  ONCEHASH                 ; -> KERNEL MIT ZHLER (-1)
;
;
;
NONANO30:     CJNE A,#03H,NONANO03          ; NANO-COMMAND 03H ?
              SETB BREAKFLAG                ; JA, DANN BREAK !
              JMP  EXITNANO                 ; WEITER ...
;
;
;
NONANO03:     CJNE A,#19H,NONANO19          ; NANO-COMMAND 19H ?
              MOV  A,R0                     ; AKTUELLEN INDEX
              CLR  C
              SUBB A,#CODES+16              ; MINUS OFFSET IN INT. RAM
              CALL NEWHASH                  ; -> KERNEL
              MOV  A,#19H                   ; -> KERNEL MIT 19H
ONCEHASH:     CALL NEWHASH                  ; AUSFHREN
              JMP  EXITNANO                 ; WEITER ..
;
;
;
NONANO19:     CJNE A,#46H,EXITNANO          ; NANO-COMMAND 46H ?
              JMP  HASHEXIT                 ; JA, DANN ENDE
;
;
;
EXITNANO:     MOV  A,R0
              CLR  C
              SUBB A,#CODES+31              ; INDEX IM BEREICH 0-15 ?
              JNC  ENDNANO                  ; NEIN, DANN ENDE
              JB   BREAKFLAG,ENDNANO        ; BREAKFLAG GESETZT ?, DANN ENDE
              JMP  NANOPARSE                ; SONST NCHSTEN BEFEHL ...
;
;
;
ENDNANO:      MOV  A,R0
              SETB C
              SUBB A,#CODES+16
              MOV  R5,A
              JMP  LASTHASH                 ; UND ENDE
;
;
;
NEWHASH:      MOV  R2,DPL
              MOV  R3,DPH
              MOV  R6,A
              MOV  A,ANSWER
              ANL  A,#3FH
              MOV  B,A
              MOV  DPTR,#SKYKEYS1
              MOVC A,@A+DPTR
              MOV  R4,A
              MOV  A,B
              MOV  DPTR,#SKYKEYS2
              MOVC A,@A+DPTR
              XRL  A,R4
              MOV  B,A
              MOV  A,ANSWER
              CLR  C
              SUBB A,ANSWER+1
              XRL  A,R6
              MOV  R4,A
              MOV  A,R6
              ADD  A,B
              CLR  C
              SUBB A,ANSWER+1
              MOV  B,A
              MOV  A,R4
              MUL  AB
              XRL  A,ANSWER+2
              MOV  ANSWER+2,A
              MOV  A,ANSWER+3
              ADD  A,B
              MOV  ANSWER+3,A
              MOV  A,R6
              RL   A
              ADD  A,#49H
              MOV  R6,A
              MOV  A,ANSWER+2
              ANL  A,#3FH
              MOV  B,A
              MOV  DPTR,#SKYKEYS1
              MOVC A,@A+DPTR
              MOV  R4,A
              MOV  A,B
              MOV  DPTR,#SKYKEYS2
              MOVC A,@A+DPTR
              XRL  A,R4
              MOV  B,A
              MOV  A,ANSWER+2
              CLR  C
              SUBB A,ANSWER+3
              XRL  A,R6
              MOV  R4,A
              MOV  A,R6
              ADD  A,B
              CLR  C
              SUBB A,ANSWER+3
              MOV  B,A
              MOV  A,R4
              MUL  AB
              XRL  A,ANSWER+4
              MOV  ANSWER+4,A
              MOV  A,ANSWER+5
              ADD  A,B
              MOV  ANSWER+5,A
              MOV  A,R6
              RL   A
              ADD  A,#49H
              MOV  R6,A
              MOV  A,ANSWER+4
              ANL  A,#3FH
              MOV  B,A
              MOV  DPTR,#SKYKEYS1
              MOVC A,@A+DPTR
              MOV  R4,A
              MOV  A,B
              MOV  DPTR,#SKYKEYS2
              MOVC A,@A+DPTR
              XRL  A,R4
              MOV  B,A
              MOV  A,ANSWER+4
              CLR  C
              SUBB A,ANSWER+5
              XRL  A,R6
              MOV  R4,A
              MOV  A,R6
              ADD  A,B
              CLR  C
              SUBB A,ANSWER+5
              MOV  B,A
              MOV  A,R4
              MUL  AB
              XRL  A,ANSWER+6
              MOV  ANSWER+6,A
              MOV  A,ANSWER+7
              ADD  A,B
              MOV  ANSWER+7,A
              MOV  B,A
              MOV  A,ANSWER+6
              MUL  AB
              ADD  A,ANSWER
              MOV  R6,A
              CLR  C
              SUBB A,ANSWER
              JNC  TIED01
              INC  R6
TIED01:       MOV  A,R6
              ADD  A,#39H
              MOV  ANSWER,A
              MOV  A,B
              ADD  A,ANSWER+1
              MOV  R6,A
              CLR  C
              SUBB A,ANSWER+1
              JNC  TIED02
              INC  R6
TIED02:       MOV  A,R6
              ADD  A,#8FH
              MOV  ANSWER+1,A
              MOV  DPL,R2
              MOV  DPH,R3
              RET
;
;
;
DOADULT:      CLR  NOFIT                    ; FEHLERFLAG LSCHEN
              MOV  R0,#ANSWER
              MOV  R2,#8
              CALL ZERORAM                  ; ANTWORTPUFFER INIT.
              MOV  DPTR,#ADULTKEYS          ; ZEIGER AUF KEYTABELLE
              MOV  A,KEYINDEX               ; OFFSET IN KEYTABELLE
              MOV  B,#8                     ; * 8
              MUL  AB
              ADD  A,DPL
              MOV  DPL,A                    ; OFFSET IN TABBELE ADDIEREN
              MOV  A,B
              ADDC A,DPH
              MOV  DPH,A
              MOV  R0,#CODES
              MOV  R1,#ANSWER
              MOV  R7,#27
              MOV  R6,#0
INITHASH:     MOV  A,@R0
              CALL KERNEL
              INC  R0
              DJNZ R7,INITHASH
              MOV  R7,#4
              MOV  R4,#27
              CLR  A
HASHMAIN:     MOV  R3,A
              CALL KERNEL
              MOV  A,R3
              CALL KERNEL
              MOV  A,R0
              MOV  R3,A
              MOV  A,#ANSWER
              ADD  A,R6
              MOV  R0,A
              MOV  A,@R0
              MOV  B,A
              MOV  A,#CODES
              ADD  A,R4
              MOV  R0,A
              MOV  A,@R0
              XRL  A,B
              JZ   SIGNOKAY
              SETB NOFIT
SIGNOKAY:     MOV  A,R3
              MOV  R0,A
              MOV  A,R6
              INC  A
              ANL  A,#7
              MOV  R6,A
              INC  R1
              CJNE R1,#ANSWER+8,HASHLOOP
              MOV  R1,#ANSWER
HASHLOOP:     MOV  A,@R0
              INC  R0
              INC  R4
              DJNZ R7,HASHMAIN
              MOV  A,@R0
              MOV  R3,A
              MOV  R7,#64
FINALOOP:     MOV  A,R3
              CALL KERNEL
              DJNZ R7,FINALOOP
              JB   NOFIT,HASHEXIT           ; DECODE-FEHLER ?
              SETB ADULTFLAG                ; NEIN, DANN 07ER-KEYS
              CLR  SKYFLAG                  ; 09ER-FLAG LSCHEN
              CLR  ERRORFLAG                ; FEHLERFLAG LSCHEN
              CLR  SCANFLAG                 ; KEYSCANNER AUS
              MOV  FITCOUNT,#0              ; FEHLERZHLER INIT.
HASHEXIT:     JNB  NOFIT,KEYFITS            ; DECODE-FEHLER ?
              CLR  NOFIT                    ; JA, DANN FLAG LSCHEN
              JB   ERRORFLAG,CHECKSCAN      ; OFFSET IN KEYTABELLE NDERN ?
              MOV  A,FITCOUNT               ; NEIN, DANN FEHLERZHLER LADEN
              INC  A                        ; UND ERHHEN
              MOV  FITCOUNT,A               ; UND ZURCKSCHREIBEN
              CJNE A,#2,KEYFITS             ; FEHLERZHLER = 02 ?
              SETB ERRORFLAG                ; JA, DANN FEHLERFLAG SETZEN
CHECKSCAN:    JNB  SCANFLAG,KEYFITS
              MOV  A,KEYINDEX
              INC  A                        ; OFFSET IN KEYTABELLE * 8
              ANL  A,#0FH                   ; MOD 16
              MOV  KEYINDEX,A
KEYFITS:      SETB ANSWERFLAG
              SETB RLED                     ; ROTE LED AUS
              CLR  CODEFLAG                 ; FLAG LSCHEN
              JMP  MAINLOOP                 ; ENDE
;
;
;
KERNEL:       MOV  B,A
              XRL  A,@R1
              MOV  @R1,A
              SWAP A
              ANL  A,#0FH
              MOVC A,@A+DPTR
              MOV  R2,A
              MOV  A,@R1
              ANL  A,#0FH
              ADD  A,#16
              MOVC A,@A+DPTR
              ADD  A,R2
              CPL  A
              RL   A
              ADD  A,B
              SWAP A
              RL   A
              INC  R1
              CJNE R1,#ANSWER+8,NOBEGIN
              MOV  R1,#ANSWER
NOBEGIN:      XRL  A,@R1
              MOV  @R1,A
              MOV  A,R6
              INC  A
              ANL  A,#7
              MOV  R6,A
              RET
;
;
;
INIT_IRAM:    MOV  R0,#1
              CLR  A                        ; INTERNES RAM VON 08-5F LSCHEN
FILL_RAM:     MOV  @R0,A
              INC  R0
              CJNE R0,#60H,FILL_RAM
              SETB INVERT                   ; BYTES INVERTIERT SENDEN/EMPFANGEN
              MOV  DPTR,#RAMSTART           ; EXTERNER SPEICHER-START
              MOV  A,#22H                   ; MIT OPCODE "RET" INIT.
              MOVX @DPTR,A
              MOV  DPTR,#EXTPROG
              MOVX @DPTR,A
              CALL RCVDATA                  ; BYTE VON EEPROM LESEN
              JC   NOEEPROM                 ; FEHLER ?
              CJNE A,#55H,NOEEPROM          ; 1.BYTE = 55H ?
              CALL RCVDATA                  ; BYTE VON EEPROM LESEN
              JC   NOEEPROM                 ; FEHLER ?
              CJNE A,#0AAH,NOEEPROM         ; 2.BYTE = AAH ?
              CALL RCVDATA                  ; BYTE VON EEPROM LESEN
              JC   NOEEPROM                 ; FEHLER ?
              MOV  OPTION1,A                ; 3.BYTE = OPTIONEN #1
              CALL RCVDATA                  ; BYTE VON EEPROM LESEN
              JC   NOEEPROM                 ; FEHLER ?
              MOV  OPTION2,A                ; 4.BYTE = OPTIONEN #2
              CALL RCVDATA                  ; BYTE VON EEPROM LESEN
              JC   NOEEPROM                 ; FEHLER ?
              MOV  ATRDELAYL,A              ; 5.BYTE = ANSWER-TO-RESET-DELAY LSB
              CALL RCVDATA                  ; BYTE VON EEPROM LESEN
              JC   NOEEPROM                 ; FEHLER ?
              MOV  ATRDELAYM,A              ; 6.BYTE = ANSWER-TO-RESET-DELAY MSB
              CALL RCVDATA                  ; BYTE VON EEPROM LESEN
              JC   NOEEPROM                 ; FEHLER ?
              MOV  BDELAY,A                 ; 7.BYTE = DELAY FR 'BYTE-SENDEN'
              CALL RCVDATA                  ; BYTE VON EEPROM LESEN
              JC   NOEEPROM                 ; FEHLER ?
              MOV  BAUDRATE,A               ; 8.BYTE = BAUDRATEN-TEILER
              CALL RCVDATA                  ; BYTE VON EEPROM LESEN
              JC   NOEEPROM                 ; FEHLER ?
              MOV  TABFLAGS,A               ; 9.BYTE = TABELLENFLAGS
              CALL RCVDATA                  ; BYTE VON EEPROM LESEN
              JC   NOEEPROM                 ; FEHLER ?
              MOV  ANDMASK,A                ; 10.BYTE = ANDMASKE FR 74ER-PAKET
              CALL RCVDATA                  ; BYTE VON EEPROM LESEN
              JC   NOEEPROM                 ; FEHLER ?
              MOV  XORMASK,A                ; 11.BYTE = XOR-MASKE FR 74ER-PAKET
              SETB EEPROMFLAG               ; FLAG 'EEPROM VORHANDEN' SETZEN
NOEEPROM:     JB   EEPROMFLAG,SETUPDONE     ; EEPROM VORHANDEN ?
              MOV  ATRDELAYL,#LOW  DELAYATR ; NEIN, DANN DEFAULT-WERTE
              MOV  ATRDELAYM,#HIGH DELAYATR ; SETZEN
              MOV  BDELAY,#V24DELAY
              MOV  BAUDRATE,#FIXEDBAUD
              MOV  TABFLAGS,#0
              MOV  A,#MAXTIMER              ; ANZAHL TIMERBERLUFE
              SWAP A                        ; IN BITS 4-5
              MOV  OPTION1,A                ; UND SICHERN
              CLR  A
              MOV  OPTION2,A
              MOV  ANDMASK,#0E0H
              MOV  XORMASK,#0C0H
SETUPDONE:    CALL SETOPTION                ; FLAGS SETZEN
              MOV  TL1,BAUDRATE             ; AKTUELLE BAUDRATE SETZEN
              MOV  TH1,BAUDRATE
              SETB TR1                      ; T1 ENABLE
              RET
;
;
;
SETOPTION:    MOV  A,OPTION1
              MOV  C,ACC.0
              MOV  OSDFLAG,C                ; OSD DAUERHAFT ANZEIGEN
              MOV  C,ACC.1
              MOV  NEVERFLAG,C              ; OSD NIE ANZEIGEN
              MOV  C,ACC.2
              MOV  ANSWERONE,C              ; 1.BYTE DER ANTWORT = 01
              MOV  C,ACC.3
              MOV  EXECFLAG,C               ; EXTERNAL DECODE
              MOV  C,ACC.6
              MOV  IDFLAG,C                 ; CHANNEL-ID NICHT ANZEIGEN
              MOV  C,ACC.7
              MOV  IDEXT,C                  ; ID EXTERN AUSWERTEN
              SWAP A
              ANL  A,#3                     ; ANZAHL TIMERBERLUFE
              INC  A                        ; + 1 (0-3) -> (1-4)
              MOV  TIMERCNT,A               ; SICHERN
              MOV  A,OPTION2
              MOV  C,ACC.0
              MOV  INT0FLAG,C               ; INT0 ENABLE/DISABLE
              MOV  C,ACC.1
              MOV  INT1FLAG,C               ; INT1 ENABLE/DISABLE
              MOV  C,ACC.2                  ; KEYSCANNING ENBALE
              MOV  SCANFLAG,C
              MOV  C,ACC.3                  ; DEBUGFLAG (TESTMODE) ENABLE
              MOV  DEBUGFLAG,C
              RET
;
;
;
COPY_ROM:     MOVX A,@DPTR                  ; BYTE LADEN
              MOV  @R0,A                    ; IN INT. RAM
              INC  R0                       ; ZIELZEIGER + 1
              INC  DPTR                     ; QUELLZEIGER + 1
              DJNZ R2,COPY_ROM              ; UND NCHSTES BYTE
              RET
;
;
;
COPY_XRAM:    MOV  A,@R0                    ; AUS INTERNEM SPEICHER
              MOVX @DPTR,A                  ; IN EXTERNEN SPEICHER
              INC  R0                       ; KOPIEREN
              INC  DPTR
              DJNZ R2,COPY_XRAM
              RET
;
;
;
COPY_RAM:     MOV  A,@R0                    ; BYTE LADEN
              MOV  @R1,A                    ; BYTE SPEICHERN
              INC  R0
              INC  R1                       ; ZEIGER + 1
              DJNZ R2,COPY_RAM              ; UND NCHSTES BYTE
              RET
;
;
;
ZERORAM:      CLR  A
              MOV  @R0,A                    ; AB @R0 MIT 00 SCHREIBEN
              INC  R0
              DJNZ R2,ZERORAM
              RET
;
;
;
ZEROXRAM:     CLR  A
              MOVX @DPTR,A                  ; AB @DPTR MIT 00 SCHREIBEN
              INC  DPTR
              DJNZ R2,ZEROXRAM
              RET
;
;
;
HEX2ASC:      MOV  R2,DPL
              MOV  R3,DPH                   ; ZEIGER IN STRING SICHERN
              MOV  DPTR,#HEXTABLE           ; ZEIGER AUF ASCII-TABELLE
              MOV  B,A
              SWAP A                        ; HIGH IN LOWNIBBLE
              ANL  A,#0FH                   ; BITS 0-3 (MSB)
              MOVC A,@A+DPTR                ; = OFFSET IN ASCII
              XCH  A,B
              ANL  A,#0FH                   ; BITS 0-3 (LSB)
              MOVC A,@A+DPTR                ; = OFFSET IN ASCII
              XCH  A,B
              MOV  DPL,R2                   ; ZIELZEIGER ZURCK
              MOV  DPH,R3
              MOVX @DPTR,A                  ; 1. ZEICHEN
              INC  DPTR
              MOV  A,B
              MOVX @DPTR,A                  ; 2. ZEICHEN
              INC  DPTR
              RET
;
;
;
COPYTABS:     MOV  A,TABFLAGS
              JB   ACC.0,RAMTAB1
              MOV  DPTR,#EPROMTAB1
              MOV  R3,#LOW  SKYTAB          ; KARTENTABELLE EPROM->XRAM (256 BYTES)
              MOV  R4,#HIGH SKYTAB
              MOV  R2,#0
              CALL ROM2XRAM
RAMTAB1:      JB   ACC.1,RAMTAB2
              MOV  DPTR,#EPROMTAB2
              MOV  R3,#LOW  SKYKEYS1        ; 09ER KEYTABELLE#1 EPROM->XRAM (64 BYTES)
              MOV  R4,#HIGH SKYKEYS1
              MOV  R2,#64
              CALL ROM2XRAM
RAMTAB2:      JB   ACC.2,RAMTAB3
              MOV  DPTR,#EPROMTAB3
              MOV  R3,#LOW  SKYKEYS2
              MOV  R4,#HIGH SKYKEYS2        ; 09ER KEYTABELLE#2 EPROM->XRAM (64 BYTES)
              MOV  R2,#64
              CALL ROM2XRAM
RAMTAB3:      JB   ACC.3,RAMTAB4
              MOV  DPTR,#EPROMTAB4
              MOV  R3,#LOW  ADULTKEYS
              MOV  R4,#HIGH ADULTKEYS       ; 07ER KEYTABELLE EPROM->XRAM (256 BYTES)
              MOV  R2,#0
              CALL ROM2XRAM
RAMTAB4:      JB   ACC.4,TABSDONE
              MOV  DPTR,#EPROMTAB5
              MOV  R3,#LOW  OSD             ; OSD-STRING EPROM-> XRAM
              MOV  R4,#HIGH OSD
              MOV  R2,#25
              CALL ROM2XRAM
TABSDONE:     RET
;
;
;
ROM2XRAM:     MOV  B,A
TABSLOOP:     CLR  A
              MOVC A,@A+DPTR                ; AUS EPROM
              INC  DPTR                     ; IN EXTERNEN
              MOV  R0,DPL                   ; SPEICHER
              MOV  R1,DPH                   ; KOPIEREN
              MOV  DPL,R3                   ; DPTR -> R3/R4
              MOV  DPH,R4                   ; MAX. 256 BYTES
              MOVX @DPTR,A
              INC  DPTR
              MOV  R3,DPL
              MOV  R4,DPH
              MOV  DPL,R0
              MOV  DPH,R1
              DJNZ R2,TABSLOOP
              MOV  A,B
              RET
;
;
;
INIT_SFR:     CLR  F0                       ; STATUS-FLAG LSCHEN
              CLR  TR0                      ; TIMER 0 DISABLE
              CLR  TR1                      ; TIMER 1 DISABLE
              CLR  IE1                      ; INT1 LSCHEN
              CLR  IE0                      ; INT0 LSCHEN
              SETB IT0                      ; INT0 NEGATIVE FLANKE
              SETB IT1                      ; INT1 NEGATIVE FLANKE
              MOV  PCON,#0                  ; NORMALE BAUDRATEN
              MOV  TMOD,#00100001B          ; T1=8-BIT AUTORELOAD, T0=16-BIT
              MOV  SCON,#11000000B          ; 9-BIT UART, T1=BAUDRATENGENERATOR
              SETB PX1                      ; INT1 HHERE PRIO
              CLR  TF1                      ; T1-FLAG LSCHEN
              CLR  TF0                      ; T0-FLAG LSCHEN
              CLR  EX0                      ; INT0 DISABLE
              CLR  EX1                      ; INT1 DISABLE
              CLR  ES                       ; SERIELLER INT DISABLE
              CLR  REN                      ; EMPFNGER DISABLE
              RET
;
;
;
ROTATE_ACC:   CLR  C                        ; C LSCHEN
              RRC  A                        ; BIT 0 IN CARRY
              MOV  B.7,C                    ; IN BIT 7 VON B
              RRC  A                        ; BIT 1 IN CARRY
              MOV  B.6,C                    ; IN BIT 6 VON B
              RRC  A                        ; BIT 2 IN CARRY
              MOV  B.5,C                    ; IN BIT 5 VON B
              RRC  A                        ; BIT 3 IN CARRY
              MOV  B.4,C                    ; IN BIT 4 VON B
              RRC  A                        ; BIT 4 IN CARRY
              MOV  B.3,C                    ; IN BIT 3 VON B
              RRC  A                        ; BIT 5 IN CARRY
              MOV  B.2,C                    ; IN BIT 2 VON B
              RRC  A                        ; BIT 6 IN CARRY
              MOV  B.1,C                    ; IN BIT 1 VON B
              RRC  A                        ; BIT 7 IN CARRY
              MOV  B.0,C                    ; IN BIT 0 VON B
              MOV  A,B                      ; ZURCK IN ACC
              CPL  A                        ; INVERTIEREN
              MOV  C,P                      ; PARITY
              MOV  TB8,C                    ; IN SENDEREGISTER
              CPL  TB8                      ; PARITY INVERTIEREN
              RET
;
;
;
ADD_ADRESS:   ADD  A,DPL
              MOV  DPL,A
              JNC  NO_HIGH                  ; DPTR = DPTR + A
              INC  DPH
NO_HIGH:      RET
;
;
;
SUB_ADRESS:   CLR  C
              MOV  B,A                      ; SICHERN
              MOV  A,DPL
              SUBB A,B                      ; LSB - A
              MOV  DPL,A
              MOV  A,DPH
              SUBB A,#0                     ; MSB - C
              MOV  DPH,A
              RET
;
;
;
CHECK_CNT:    MOV  A,R6                     ; LSB
              CLR  C
              SUBB A,#1                     ; - 1
              MOV  R6,A                     ; UND ZURCK
              MOV  A,R7                     ; MSB
              SUBB A,#0                     ; - 0 (-C)
              MOV  R7,A                     ; UND ZURCK
              RET
;
;
;
BITDLY:       NOP                           ; DELAY CA. 7S
              NOP
              NOP
              NOP
              NOP
              NOP
              NOP
              NOP
              RET
;
;
;
SCLHIGH:      SETB SCL                      ; SCL=1
WAIT_SCL:     MOV  R4,#0                    ; ZHLER MSB
              MOV  R5,#0                    ; ZHLER LSB
SCL_LOOP:     JB   SCL,EXIT_SCL             ; SCL = 1 ?, DANN ENDE
              DJNZ R5,SCL_LOOP              ; LSB - 1
              DJNZ R4,SCL_LOOP              ; MSB - 1
              SETB BUSFAULT                 ; FEHLERFLAG SETZEN
EXIT_SCL:     RET
;
;
;
SENDSTOP:     CLR  SDA                      ; SDA=0
              CALL SCLHIGH                  ; SCL=1
              CALL BITDLY
              SETB SDA                      ; SDA=1 (STOPSEQUENZ)
              CALL BITDLY
              CLR  I2CBUSY                  ; "BUSY"-STATUS LSCHEN
              RET
;
;
;
SENDBYTE:     MOV  R3,#8                    ; BITZHLER
SBLOOP:       RLC  A                        ; MSBIT IN CARRY
              MOV  SDA,C                    ; SDA=DATA
              CALL SCLHIGH                  ; SCL=1
              CALL BITDLY                   ; DELAY
              CLR  SCL                      ; SCL=0
              CALL BITDLY                   ; DELAY
              DJNZ R3,SBLOOP                ; NCHSTES BIT
              SETB SDA                      ; SDA=1 (FR ACK)
              CALL SCLHIGH                  ; SCL=1
              CALL BITDLY                   ; DELAY
              JNB  SDA,SBEX                 ; ACK ?, DANN WEITER
              SETB NOACK                    ; SONST FLAG SETZEN
SBEX:         CLR  SCL                      ; SCL=0
              CALL BITDLY                   ; DELAY
              RET
;
;
;
SENDACC:      SETB I2CBUSY                  ; BUS IST "BUSY"
              CLR  NOACK                    ; STATUS LSCHEN
              SETB BUSFAULT                 ; FEHLER SETZEN
              JNB  SCL,FAULT                ; SCL=1 ? NEIN, DANN FEHLER
              JNB  SDA,FAULT                ; SDA=1 ? NEIN, DANN FEHLER
              CLR  SDA                      ; SDA=0 (STARTSEQUENZ)
              CALL BITDLY                   ; DELAY
              CLR  SCL                      ; SCL=0
              CALL BITDLY                   ; DELAY
              CALL SENDBYTE                 ; ACC SENDEN
              CLR  BUSFAULT                 ; STATUS LSCHEN, ALLES OK.
FAULT:        RET
;
;
;
RCVBYTE:      MOV  R3,#8                    ; BITZHLER
RBLOOP:       SETB SDA
              CALL SCLHIGH                  ; SCL=1
              CALL BITDLY                   ; DELAY
              MOV  C,SDA                    ; C=DATA
              RLC  A                        ; IN ACC (MSB ZUERST)
              CLR  SCL                      ; SCL=0
              CALL BITDLY                   ; DELAY
              DJNZ R3,RBLOOP                ; NCHSTES BIT
              MOV  C,F0                     ; C=FLAG
              MOV  SDA,C                    ; UND C IN SDA
              CALL SCLHIGH                  ; SCL=1
              CALL BITDLY                   ; DELAY
              CLR  SCL                      ; SCL=0
              SETB SDA                      ; SDA=1
              CALL BITDLY                   ; DELAY
              RET
;
;
;
RCVDATA:      CLR  F0                       ; ACK=0
              JB   RANDOMFLAG,SEQUENTIAL
              MOV  A,#EEPROM                ; GERTEADRESSE EEPROM 24C65
              ANL  A,#11111110B
              CALL SENDACC
              JB   NOACK,RDEX               ; FEHLER ?
              JB   BUSFAULT,RDEX
              MOV  A,EEPROM_MSB             ; ADRESS-MSB
              CALL SENDBYTE                 ; SENDEN
              JB   NOACK,RDEX               ; FEHLER ?
              JB   BUSFAULT,RDEX
              MOV  A,EEPROM_LSB             ; ADRESS-LSB
              CALL SENDBYTE                 ; SENDEN
              JB   NOACK,RDEX               ; FEHLER ?
              JB   BUSFAULT,RDEX
              CALL SCLHIGH
              CALL BITDLY
              MOV  A,#EEPROM                ; GERTEADRESSE
              ORL  A,#00000001B             ; READ-BIT
              CALL SENDACC                  ; SENDEN
              JB   NOACK,RDEX               ; FEHLER ?
              JB   BUSFAULT,RDEX
              SETB F0                       ; ACK=1
              CALL RCVBYTE
              JB   NOACK,RDEX               ; FEHLER ?
              JB   BUSFAULT,RDEX
              CALL SENDSTOP                 ; END OF TRANSMISSION
              SETB RANDOMFLAG
              CLR  C
              RET
;
;
;
SEQUENTIAL:   CALL BITDLY                   ; BUS-FREE-TIME
              MOV  A,#EEPROM                ; GERTEADRESSE
              ORL  A,#00000001B             ; READ-BIT
              CALL SENDACC                  ; SENDEN
              JB   NOACK,RDEX               ; FEHLER ?
              JB   BUSFAULT,RDEX
              SETB F0                       ; ACK=1
              CALL RCVBYTE
              JB   NOACK,RDEX               ; FEHLER ?
              JB   BUSFAULT,RDEX
              CALL SENDSTOP
              CLR  C
              RET
;
;
;
RDEX:         CALL SENDSTOP                 ; STOP-SEQUENZ
              CLR  RANDOMFLAG               ; FLAG LSCHEN
              CLR  EEPROMFLAG               ; 'EEPROM-FEHLER'
              SETB C                        ; FEHLER !
              RET
;
;
;
READEEPROM:   CLR  F0                       ; ACK=0
              CALL BITDLY                   ; BUS-FREE-TIME
              MOV  A,#EEPROM                ; GERTEADRESSE
              ORL  A,#00000001B             ; READ-BIT
              CALL SENDACC                  ; SENDEN
              JB   NOACK,RDEX               ; FEHLER ?
              JB   BUSFAULT,RDEX
              MOV  CHECKSUM,#0              ; PRFSUMME = 00
              CALL RCVBYTE                  ; BYTE LESEN
              JB   NOACK,RDEX               ; FEHLER ?
              JB   BUSFAULT,RDEX
              MOV  R6,A                     ; ANZAHL BYTES LSB
              ADD  A,CHECKSUM               ; ZU PRFSUMME ADDIEREN
              MOV  CHECKSUM,A
              CALL RCVBYTE                  ; BYTE LESEN
              JB   NOACK,RDEX               ; FEHLER ?
              JB   BUSFAULT,RDEX
              MOV  R7,A                     ; ANZAHL BYTES MSB
              MOV  B,A                      ; SICHERN
              ADD  A,CHECKSUM               ; ZU PRFSUMME ADDIEREN
              MOV  CHECKSUM,A
              MOV  A,B                      ; ANZAHL BYTES
              XRL  A,R6                     ; = 0 ?
              JZ   RDEX                     ; JA, DANN FEHLER
XRAMLOOP:     CALL RCVBYTE                  ; BYTE LESEN
              JB   NOACK,RDEX               ; FEHLER ?
              JB   BUSFAULT,RDEX
              MOVX @DPTR,A                  ; IN EXTERNEN SPEICHER
              ADD  A,CHECKSUM
              MOV  CHECKSUM,A               ; ZU PRFSUMME ADDIEREN
              INC  DPTR
              CALL CHECK_CNT                ; NOCH'N BYTE ?
              JNC  XRAMLOOP                 ; JAU, DANN WEITER
              SETB F0                       ; ACK=1
              CALL RCVBYTE                  ; BYTE LESEN
              JB   NOACK,RDEX               ; FEHLER ?
              JB   BUSFAULT,RDEX
              XRL  A,CHECKSUM               ; BYTE = PRFSUMME
              JNZ  RDEX                     ; NEIN, DANN FEHLER
              CALL SENDSTOP                 ; STOPSEQUENZ
              CLR  C                        ; 'ALLES KLAR' !
              RET
;
;
;
RCVXRAM:      MOV  A,OPTION1
              JNB  ACC.3,NOEXECPROG
              MOV  DPTR,#RAMSTART
              CALL READEEPROM               ; EXTERNES DECODE-PROG. LADEN
              JC   ENDEEPROM
NOEXECPROG:   MOV  A,OPTION1
              JNB  ACC.7,NOEXTPRG
              MOV  DPTR,#EXTPROG
              CALL READEEPROM               ; EXTERNE ID-BEHANDLUNG LADEN
              JC   ENDEEPROM
NOEXTPRG:     MOV  A,TABFLAGS
              JNB  ACC.0,NOTAB1
              MOV  DPTR,#SKYTAB
              CALL READEEPROM               ; KARTENTABELLE LADEN
              JC   ENDEEPROM
NOTAB1:       MOV  A,TABFLAGS
              JNB  ACC.1,NOTAB2
              MOV  DPTR,#SKYKEYS1           ; 09ER KEYTABELLE#1 LADEN
              CALL READEEPROM
              JC   ENDEEPROM
NOTAB2:       MOV  A,TABFLAGS
              JNB  ACC.2,NOTAB3
              MOV  DPTR,#SKYKEYS2           ; 09ER KEYTABELLE#2 LADEN
              CALL READEEPROM
              JC   ENDEEPROM
NOTAB3:       MOV  A,TABFLAGS
              JNB  ACC.3,NOTAB4
              MOV  DPTR,#ADULTKEYS          ; 07ER KEYTABELLE LADEN
              CALL READEEPROM
              JC   ENDEEPROM
NOTAB4:       MOV  A,TABFLAGS
              JNB  ACC.4,ENDEEPROM
              MOV  DPTR,#OSD
              CALL READEEPROM               ; OSD-STRING LADEN
ENDEEPROM:    RET
;
;
;
SENDV24:      MOV  B,A
              MOV  A,BDELAY                 ; WARTEZEIT
              CALL DELAY                    ; UND WARTEN !
              MOV  A,B
SENDTHRU:     CLR  ES                       ; SERIELLER INT AUS
              CLR  REN                      ; EMPFNGER AUS
              MOV  C,P                      ; PARITT INS CARRY
              MOV  TB8,C                    ; = 9. DATENBIT
              JNB  INVERT,SENDIT            ; INVERTIEREN ?
              CALL ROTATE_ACC               ; JA, DANN ACCU ZURECHTDRSELN
SENDIT:       MOV  SBUF,A                   ; ACC IN SENDEREGISTER
              JNB  TI,$                     ; FERTIG ?
              CLR  TI                       ; FLAG LSCHEN
              CLR  RI                       ; FLAG LSCHEN
              SETB REN                      ; EMPFNGER EIN
              SETB ES                       ; INT EIN
              RET
;
;
;
DELAY:        JZ   EXDELAY
              NOP                           ; WARTESCHLEIFE
              DEC  A
              JNZ  DELAY
EXDELAY:      RET
;
;
;
DO_T0INT:     PUSH ACC
              PUSH B
              PUSH DPH
              PUSH DPL
              PUSH PSW
              MOV  PSW,#00001000B           ; REG.BANK 01
              SETB RLED                     ; LED'S AUS
              SETB GLED
              CLR  TR0                      ; TIMER 0 STOPPPP !
              CLR  ET0                      ; TIMER 0-INT AUS
              DEC  TIMERCNT                 ; BERLAUFZHLER - 1
              MOV  A,TIMERCNT               ; UND LESEN
              JZ   ATRSEND                  ; SCHON 0 ?
              MOV  TL0,ATRDELAYL            ; NEIN, DANN LSB SETZEN
              MOV  TH0,ATRDELAYM            ; BERLAUFRATE MSB SETZEN
              SETB ET0                      ; T0-INT ENABLE
              SETB TR0                      ; TIMER 0 START !
              POP  PSW
              POP  DPL
              POP  DPH                      ; UND ENDE
              POP  B
              POP  ACC
              RETI
;
;
;
ATRSEND:      MOV  DPTR,#ATR                ; ZEIGER AUF ANSWER-TO-RESET
              MOV  R0,#16                   ; 16 BYTES
SENDATR:      MOVX A,@DPTR
              CALL SENDV24                  ; BYTE AN DEKODER
              INC  DPTR
              DJNZ R0,SENDATR               ; UND NCHSTES BYTE
              CLR  IE1                      ; INT1-FLAG LSCHEN
              POP  PSW
              POP  DPL
              POP  DPH
              POP  B
              POP  ACC
              MOV  C,INT1FLAG
              MOV  EX1,C                    ; INT1 ENABLE/DISABLE
              MOV  C,INT0FLAG
              MOV  EX0,C                    ; INT0 ENABLE/DISABLE
              RETI
;
;
;
DO_V24INT:    CLR  EX1
              PUSH ACC
              PUSH B
              PUSH DPH
              PUSH DPL
              PUSH PSW
              MOV  PSW,#00001000B           ; REG.BANK 01
              JNB  RI,EXITV24               ; BYTE EMPFANGEN ?
              CPL  GLED                     ; GRNE LED TOGGELN
              MOV  A,SBUF                   ; BYTE LADEN
              JNB  INVERT,GETIT             ; UMDREHEN ?
              CALL ROTATE_ACC               ; JA, DANN LOS
GETIT:        MOV  BYTE,A                   ; BYTE ERSTMAL SICHERN
EXECINS:      MOV  DPTR,#TABLE              ; SPRUNGTABELLE
              MOV  A,COUNT                  ; ZHLER LADEN
              MOV  B,A
              CLR  C
              RLC  A                        ; ZHLER * 2
              ADD  A,B                      ; + ZHLER (= ZHLER * 3)
              JMP  @A+DPTR                  ; UND AUSFHREN
;
;
;
HEADERFAULT:  MOV  COUNT,#0                 ; ZHLER WIEDER AUF NULL !
EXITV24:      CLR  RI                       ; FLAGS LSCHEN
              CLR  TI
              POP  PSW
              POP  DPL
              POP  DPH
              POP  B
              POP  ACC
              MOV  C,INT1FLAG
              MOV  EX1,C                    ; INT1 ENABLE/DISABLE
              MOV  C,INT0FLAG
              MOV  EX0,C                    ; INT0 ENABLE/DISABLE
              RETI
;
;
;
GETCLA:       MOV  A,BYTE                   ; CLASSCODE (CLA)
              CJNE A,#53H,EXITV24           ; GLTIGER CLASSCODE ?
              INC  COUNT                    ; JAU, DANN ZHLER + 1 (=1)
              JMP  EXITV24
;
;
;
GETINS:       MOV  A,BYTE                   ; INSTRUCTIONCODE (INS)
              JB   ACC.0,HEADERFAULT        ; BIT 0 = 1, DANN FEHLER
              MOV  INSBYTE,A                ; SONST SICHERN
              INC  COUNT                    ; ZHLER + 1  (=2)
              JMP  EXITV24
;
;
;
GETPX:        MOV  A,BYTE                   ; P1 UND P2 WERDEN HIER
              JNZ  HEADERFAULT              ; BERPRFT (BEIDE = NULL)
              INC  COUNT                    ; ZHLER + 1 (=3 UND 4)
              JMP  EXITV24
;
;
;
GETP3:        MOV  A,BYTE                   ; ANZAHL BYTES
              MOV  INSCOUNT,A               ; ERSTMAL SICHERN
              MOV  B,INSBYTE                ; INS LADEN
              MOV  R2,#10                   ; 10 INS-CODE GIBT ES
              MOV  R4,#5                    ; ZHLER MIT 5 VORBESETZEN
              MOV  DPTR,#INSTABLE           ; ZEIGER AUF TABELLE
SEARCHINS:    MOVX A,@DPTR                  ; INS MIT TABELLE VERGLEICHEN
              XRL  A,B
              JZ   INSFOUND                 ; GEFUNDEN !!
              INC  DPTR
              INC  R4                       ; ZHLER + 1
              DJNZ R2,SEARCHINS             ; UND WEITERSUCHEN
              MOV  A,#90H                   ; SW1 = 90
              CALL SENDV24                  ; AN DEKODER
              MOV  A,#01H                   ; SW2 = 01
              CALL SENDV24                  ; AN DEKODER (FEHLER)
              JMP  HEADERFAULT              ; UND ENDE
;
;
;
INSFOUND:     MOV  A,R4                     ; INS-ZHLER
              MOV  COUNT,A                  ; SICHERN
              JMP  EXECINS                  ; UND INS AUSFHREN
;
;
;
SENDINS:      MOV  A,INSBYTE                ; INS
              CALL SENDV24                  ; AN DEKODER (ALLE WEITEREN BYTES
              RET                           ; KOMPLETT BERTRAGEN)
;
;
;
SENDSWX:      MOV  A,#90H                   ; SW1 = 90
              CALL SENDV24                  ; AN DEKODER
              CLR  A                        ; SW2 = 00
              CALL SENDV24                  ; AN DEKODER (ALLES KLAR!)
              RET
;
;
;
SENDPUFFER:   MOV  DPTR,#BUFFER
              MOV  R2,INSCOUNT
PUFFERLOOP:   MOVX A,@DPTR                  ; PUFFERINHALT AN DEKODER SENDEN
              CALL SENDV24
              INC  DPTR
              DJNZ R2,PUFFERLOOP
              RET
;
;
;
SETCOUNT:     MOV  A,COUNT                  ; ZHLER ERSTMAL
              MOV  PRECOUNT,A               ; ZWISCHENSPEICHERN
              MOV  COUNT,#15                ; ZEIGER AUF "BYTES IN PUFFER LESEN"
              MOV  XCOUNT,#0                ; PUFFERINDEX SETZEN
              RET
;
;
;             INS = 70
;
;             KARTENINFORMATIONEN VON KARTE LESEN (6 BYTES)
;             DECODER <- KARTE
;
;
INS70:        CALL SENDINS                  ; INS AN DEKODER
              MOV  DPTR,#BUFFER
              MOV  R2,INSCOUNT
              CALL ZEROXRAM                 ; 6 NULLBYTES GENERIEREN
              CALL SENDPUFFER               ; PUFFER AN DEKODER
              CALL SENDSWX                  ; SW1 SW2 AN DEKODER
              MOV  COUNT,#0
              JMP  EXITV24
;
;
;             INS = 72
;
;             BYTES VON VORHERIGER KARTE SENDEN (16 BYTES)
;             DECODER -> KARTE
;
;
INS72:        JB   DATAFLAG,INS72DONE       ; ALLE 16 BYTES EINGELESEN ?
              CALL SENDINS                  ; INS AN DEKODER
              CALL SETCOUNT                 ; INIT.
              JMP  EXITV24                  ; ENDE
;
;
;
INS72DONE:    CLR  DATAFLAG                 ; FLAG LSCHEN
              CALL SENDSWX                  ; SW1 SW2 AN DEKODER
              MOV  COUNT,#0
              JMP  EXITV24                  ; ENDE
;
;
;             INS = 74
;
;             32 CODEBYTES AN KARTE
;             DECODER -> KARTE
;
;
INS74:        MOV  R0,#ANSWER
              MOV  R2,#8                    ; ANTWORTPUFFER INIT.
              CALL ZERORAM
              CALL SENDINS                  ; INS AN DECODER
              MOV  DPTR,#NANOBUFFER
              MOV  R2,#16                   ; NANO-PUFFER INIT.
              CALL ZEROXRAM
              CALL SETCOUNT                 ; INIT.
              MOV  COUNT,#16                ; IN INTERNES RAM
              MOV  POINTER,#CODES           ; PUFFERZEIGER SETZEN
              MOV  INSCOUNT,#12             ; 1.SCHLEIFE=12 BYTES
              CLR  ANSWERFLAG               ; ANTWORTFLAG LSCHEN
              MOV  LASTCOUNT,#0             ; ZHLER INIT.
              JMP  EXITV24                  ; ENDE
;
;
;
;             INS = 76
;
;             AUTHORIZE-TASTER BETTIGT (1 BYTE)
;             DECODER -> KARTE
;
;
INS76:        JB   DATAFLAG,INS76DONE       ; BYTE GELESEN ?
              CALL SENDINS                  ; INS AN DECODER
              CALL SETCOUNT                 ; INIT.
              JMP  EXITV24
;
;
;
INS76DONE:    CLR  DATAFLAG                 ; FLAG LSCHEN
              CALL SENDSWX                  ; SW1 SW2 AN DECODER
              MOV  COUNT,#0
              JMP  EXITV24
;
;
;             INS = 78
;
;             8 ANTWORTBYTES LESEN
;             DECODER <- KARTE
;
;
INS78:        MOV  A,07H
              MOV  LASTCOUNT,A              ; ZHLER FR DEBUG SICHERN.
              JNB  ANSWERFLAG,NOTREADY      ; ANTWORT FERTIG ?
              JB   NOFIT,NOTREADY           ; DECODE-FEHLER ?
              JB   READYFLAG,GOTIT          ; HAUPTPROGRAMM SOWEIT ?
NOTREADY:     CALL SENDINS                  ; INS AN DEKODER
              MOV  DPTR,#BUFFER
              MOV  R2,#8                    ; 8 NULLBYTES
              CALL ZEROXRAM
              MOV  DPTR,#BUFFER             ; JA, DANN ERSTES BYTE
              CLR  A
              JNB  ANSWERONE,NOONE          ; FLAG GESETZT ?
              MOV  A,#1                     ; DES ANTWORTPUFFERS
              MOVX @DPTR,A                  ; AUF 01 SETZEN
NOONE:        JNB  DEBUGFLAG,NOTEST
              MOV  C,ANSWERFLAG
              CPL  C
              MOV  ACC.7,C
              MOVX @DPTR,A
NOTEST:       CALL SENDPUFFER               ; AN DEKODER
              CALL SENDSWX                  ; SW1 SW2 AN DECODER
              MOV  COUNT,#0
              JMP  EXITV24
;
;
;
GOTIT:        MOV  A,CODES                  ; SCRAMBLEFLAG
              ANL  A,ANDMASK                ; AND AND-MASK
              XRL  A,XORMASK                ; XOR XOR-MASK
              JZ   NOTREADY                 ; = 0 ?, DANN SOFTSCRAMBLED
              CALL SENDINS                  ; INS SENDEN
              MOV  A,ANSWER+7
              ANL  A,#0FH                   ; NUR 60 BIT !
              MOV  ANSWER+7,A
              MOV  R0,#ANSWER               ; QUELLZEIGER
              MOV  DPTR,#BUFFER             ; ZIELZEIGER
              MOV  R2,#8                    ; 8 BYTES
              CALL COPY_XRAM                ; KOPIEREN
              MOV  INSCOUNT,#8
              CALL SENDPUFFER               ; ANSWER AN DEKODER
              CALL SENDSWX                  ; SW1 SW2 AN DECODER
              MOV  COUNT,#0
              JMP  EXITV24
;
;
;             INS = 7A
;
;             AUF DEM BILDSCHIRM AUZUGEBENDEN TEXT VON KARTE LESEN (25 BYTES)
;             DECODER <- KARTE
;
;
INS7A:        MOV  DPTR,#OSD
              MOV  R3,#LOW  BUFFER          ; OSD-MELDUNG
              MOV  R4,#HIGH BUFFER          ; IN SENDEPUFFER
              MOV  R2,#25                   ; KOPIEREN
              CALL ROM2XRAM
              CALL SENDINS                  ; INS SENDEN
              CALL GENCHANNEL               ; CHANNEL-ID GENERIEREN
              JB   DEBUGFLAG,DISPLAY        ; TESTMODUS !
              JB   SCANFLAG,DISPLAY         ; KEYSCAN !
              JB   OSDFLAG,DISPLAY          ; OSD DAUERHAFT ANZEIGEN ?
              MOV  DPTR,#BUFFER             ; NEIN, DANN
              MOV  A,#80H                   ; 1.BYTE = 80
              MOVX @DPTR,A
              JB   NEVERFLAG,DISPLAY        ; OSD NIE ANZEIGEN ?
              MOV  A,OSDCOUNT               ; NEIN, DANN ZHLER LADEN
              XRL  A,#MAXOSD                ; MIT MAXIMUM VERGLEICHEN
              JZ   DISPLAY                  ; MAXIMUM ERREICHT ?, DANN OSD AUS
              INC  OSDCOUNT                 ; SONST ZHLER + 1
DISPOSD:      MOV  A,#0D8H                  ; 1. BYTE = D8 (OSD ANZEIGEN)
              MOVX @DPTR,A
DISPLAY:      CALL SENDPUFFER               ; STRING AN DECODER
              CALL SENDSWX                  ; SW1 SW2 AN DECODER
              MOV  COUNT,#0
              JMP  EXITV24
;
;
;
RUNPROG:      MOV  DPTR,#EXTPROG            ; ZEIGER AUF EXT. PROGRAMM
              CLR  A
              JMP  @A+DPTR                  ; UND AUSFHREN
;
;
;
DODEBUG:      MOV  DPTR,#BUFFER+1
              MOV  A,#20H
              MOV  R2,#24
ERASEOSD:     MOVX @DPTR,A                  ; OSD MIT LEERZEICHEN FLLEN
              INC  DPTR
              DJNZ R2,ERASEOSD
              MOV  DPTR,#BUFFER+1           ; ZEIGER IN OSD
              MOV  A,CODES                  ; 1.BYTE DES 74ER PAKETS
              CALL HEX2ASC
              INC  DPTR
              MOV  A,CODES+1                ; 2.BYTE DES 74ER PAKETS (MONATSZHLER)
              CALL HEX2ASC
              INC  DPTR
              MOV  A,CODES+6                ; 6.BYTE DES 74ER PAKETS (CHANNELID)
              CALL HEX2ASC
              INC  DPTR
              MOV  A,#30H
              MOV  C,NANOFLAG               ; NANOCOMMAND-FLAG
              MOV  ACC.0,C
              MOVX @DPTR,A
              INC  DPTR
              INC  DPTR
              MOV  C,ERRORFLAG              ; FEHLERFLAG (DECODE)
              MOV  ACC.0,C
              MOVX @DPTR,A
              INC  DPTR
              MOV  C,EXECFLAG               ; FLAG FR EXT. DECODE (NANO)
              MOV  ACC.0,C
              MOVX @DPTR,A
              INC  DPTR
              INC  DPTR
              MOV  C,IDEXT                  ; FLAG FR EXT. ID-VERARBEITUNG
              MOV  ACC.0,C
              MOVX @DPTR,A
              INC  DPTR
              INC  DPTR
              INC  DPTR
              MOV  A,LASTCOUNT              ; ZHLER FR DECODE
              CALL HEX2ASC
              INC  DPTR
              MOV  A,SUBADRMSB              ; ADRESSE MSB DES NANOCOMMANDS 09
              CALL HEX2ASC
              MOV  A,SUBADRLSB              ; ADRESSE LSB DES NANOCOMMANDS 09
              CALL HEX2ASC
              RET
;
;
;
DOSCAN:       MOV  DPTR,#BUFFER+13
              MOV  R3,DPL                   ; OSD-MELDUNG
              MOV  R4,DPH                   ; IN SENDEPUFFER
              MOV  DPTR,#SCANTEXT
              MOV  R2,#12                   ; KOPIEREN
              CALL ROM2XRAM
              MOV  DPTR,#BUFFER+23
              MOV  A,KEYINDEX
              CALL HEX2ASC
              RET
;
;
;
GENCHANNEL:   JB   DEBUGFLAG,DODEBUG        ; TESTMODE EIN ?
              JB   SCANFLAG,DOSCAN          ; KEYSCAN ENABLED ?
              JB   IDFLAG,EXITCHANNEL       ; CHANNEL-ID ANZEIGEN ?
              JB   IDEXT,RUNPROG            ; EXTERNES PROGRAMM ?
              JB   NOFIT,EXITCHANNEL        ; DECODE-FEHLER ?
              MOV  B,#0                     ; ".CODE ERROR."
              JB   ERRORFLAG,COPYID         ; BEI FEHLER ANZEIGEN
              JNB  ADULTFLAG,NOADLT         ; 07ER DECODE ?
              MOV  B,#8                     ; JA, DANN "ADULT CHANNEL"
              MOV  A,CHANNELID              ; AKTUELLE ID LESEN
              CJNE A,#63H,NOADLT            ; ID = 63 ?
              MOV  B,#9                     ; JA, DANN "EUROTICA"
NOADLT:       JB   ADULTFLAG,COPYID         ; AUSGABE
              MOV  B,#7                     ; "JSTV EUROPE"
              MOV  A,CHANNELID
              XRL  A,#1                     ; CHANNEL-ID = 01 -> JSTV
              JZ   COPYID
              MOV  A,CHANNELID
              ANL  A,#0FH                   ; NUR BITS 0-3
              MOV  B,A
              MOV  R2,#6                    ; SECHS BEKANNTE ID'S (MULTICHANNEL)
              MOV  R4,#1                    ; INDEX IN STRINGS
              MOV  DPTR,#IDTABLE            ; TABELLE
SEARCHID:     MOVX A,@DPTR
              XRL  A,B                      ; ID MIT TABELLE VERGLEICHEN
              JZ   IDFOUND                  ; GEFUNDEN, DANN AUSFHREN
              INC  DPTR
              INC  R4
              DJNZ R2,SEARCHID              ; SONST WEITERSUCHEN
              JMP  EXITCHANNEL              ; NICHT GEFUNDEN, DANN ENDE
;
;
;
IDFOUND:      MOV  B,R4                     ; INDEX IN STRINGS
COPYID:       MOV  A,#12                    ; ZEILENLNGE
              MUL  AB                       ; * INDEX
              MOV  DPTR,#BUFFER+13
              MOV  R3,DPL
              MOV  R4,DPH
              MOV  DPTR,#CHANNELS
              CALL ADD_ADRESS               ; ZEIGER AUF TEXT BERECHNEN
              MOV  R2,#12
              CALL ROM2XRAM                 ; UND STRING IN SENDEPUFFER
EXITCHANNEL:  RET
;
;
;             INS = 7C
;
;             MESSAGE AN NCHSTE KARTE (16 BYTES)
;             DECODER <- KARTE
;
;
INS7C:        CALL SENDINS                  ; INS AN DECODER
              MOV  DPTR,#BUFFER
              MOV  R2,INSCOUNT              ; 16 NULLBYTES IN SENDEPUFFER
              CALL ZEROXRAM
              JNB  DEBUGFLAG,SEND16         ; TESTMODE ?
              MOV  DPTR,#NANOBUFFER         ; JA, DANN NANO-PUFFER
              MOV  R3,#LOW  BUFFER
              MOV  R4,#HIGH BUFFER          ; IN SENDEPUFFER
              MOV  R2,#16                   ; KOPIEREN
              CALL ROM2XRAM
SEND16:       CALL SENDPUFFER               ; AN DECODER
              CALL SENDSWX                  ; SW1 SW2 AN DECODER
              MOV  COUNT,#0
              JMP  EXITV24
;
;
;             INS = 7E
;
;             FIAT-SHAMIR-TEST (64 BYTES)
;             DECODER <- KARTE
;
;
INS7E:        CALL SENDINS                  ; INS AN DECODER
              MOV  DPTR,#BUFFER
              MOV  R2,INSCOUNT              ; 64 NULLBYTES
              CALL ZEROXRAM
              CALL SENDPUFFER               ; AN DECODER
              CALL SENDSWX
              MOV  COUNT,#0
              JMP  EXITV24
;
;
;             INS = 80
;
;             FIAT-SHAMIR-TEST (1 BYTE)
;             DECODER -> KARTE
;
;
INS80:        JB   DATAFLAG,INS80DONE       ; BYTE GELESEN ?
              CALL SENDINS                  ; N, DANN INS AN DECODER
              CALL SETCOUNT                 ; INIT.
              JMP  EXITV24
;
;
;
INS80DONE:    CLR  DATAFLAG                 ; FLAG LSCHEN
              CALL SENDSWX                  ; SW1 SW2 AN DECODER
              MOV  COUNT,#0
              JMP  EXITV24
;
;
;             INS = 82
;
;             FIAT-SHAMIR-TEST (64 BYTES)
;             DECODER <- KARTE
;
;
INS82:        CALL SENDINS                  ; INS AN DECODER
              MOV  DPTR,#BUFFER
              MOV  R2,INSCOUNT              ; 64 NULLBYTES
              CALL ZEROXRAM
              CALL SENDPUFFER               ; AN DECODER SENDEN
              CALL SENDSWX                  ; SW1 SW2 AN DECODER
              MOV  COUNT,#0
NEXTBYTE:     JMP  EXITV24
;
;
;
STOREX:       MOV  DPTR,#BUFFER
              MOV  A,XCOUNT                 ; INDEX IN PUFFER
              CALL ADD_ADRESS               ; ADRESSE + INDEX
              MOV  A,BYTE                   ; AKTUELLES DATENBYTE
              MOVX @DPTR,A                  ; IN SPEICHER
              INC  XCOUNT                   ; INDEX + 1
              DJNZ INSCOUNT,NEXTBYTE        ; NOCHN BYTE ?
              SETB DATAFLAG                 ; NEIN, DANN FLAG SETZEN
              MOV  A,PRECOUNT               ; ALTEN ZHLER
              MOV  COUNT,A                  ; WIEDERHERSTELLEN
              JMP  EXECINS                  ; UND INS AUSFHREN
;
;
;
STOREI1:      MOV  R0,POINTER               ; ZEIGER INTERNES RAM
              MOV  A,BYTE
              MOV  @R0,A                    ; BYTE IN PUFFER
              INC  POINTER                  ; ZEIGER + 1
              CALL NEWHASH                  ; -> KERNEL MIT AKT. BYTE AUFRUFEN
              DJNZ INSCOUNT,NEXTBYTE        ; NOCHN BYTE ?
              MOV  A,CODES+1
              XRL  A,CODES+2
              SWAP A
              MOV  TEMP1,A
              MOV  A,CODES+2
              MOV  TEMP2,A
              MOV  ADRESSLSB,#LOW  NANOBUFFER
              MOV  ADRESSMSB,#HIGH NANOBUFFER
              MOV  INSCOUNT,#4
              MOV  COUNT,#17
              JMP  EXITV24
;
;
;
STOREI2:      MOV  R0,POINTER               ; ZEIGER INTERNES RAM
              MOV  A,BYTE
              MOV  @R0,A                    ; BYTE IN PUFFER
              INC  POINTER                  ; ZEIGER + 1
              MOV  DPL,ADRESSLSB
              MOV  DPH,ADRESSMSB
              MOV  A,TEMP2
              RL   A
              ADD  A,TEMP1
              MOVX @DPTR,A
              MOV  TEMP2,A
              INC  DPTR
              MOV  ADRESSLSB,DPL
              MOV  ADRESSMSB,DPH
              DJNZ INSCOUNT,GETNEXT         ; NOCHN BYTE ?
              MOV  DPTR,#NANOBUFFER
              MOVX A,@DPTR
              XRL  A,CODES+3
              CJNE A,#80H,NONANOCMD
              SETB NANOFLAG
NONANOCMD:    MOV  A,#2
              MOVC A,@A+DPTR
              MOV  TEMP2,A
              MOV  ADRESSLSB,DPL
              MOV  ADRESSMSB,DPH
              MOV  COUNT,#18
              MOV  INSCOUNT,#15
              MOV  CODEPNT,#CODES+12
GETNEXT:      JMP  EXITV24
;
;
;
STOREI3:      MOV  R0,POINTER               ; ZEIGER INTERNES RAM
              MOV  A,BYTE
              MOV  @R0,A                    ; BYTE IN PUFFER
              INC  POINTER                  ; ZEIGER + 1
              MOV  R0,CODEPNT
              MOV  DPL,ADRESSLSB
              MOV  DPH,ADRESSMSB
              MOV  A,@R0
              MOV  B,A
              XRL  A,TEMP2
              MOVX @DPTR,A
              MOV  A,B
              CALL NEWHASH
              INC  CODEPNT
              INC  DPTR
              MOV  ADRESSLSB,DPL
              MOV  ADRESSMSB,DPH
              DJNZ INSCOUNT,GETNEXT         ; NOCHN BYTE ?
              MOV  COUNT,#19
              JMP  EXITV24
;
;
;
STOREI4:      MOV  R0,POINTER               ; ZEIGER INTERNES RAM
              MOV  A,BYTE
              MOV  @R0,A                    ; BYTE IN PUFFER
              SETB CODEFLAG                 ; NEIN, DANN FLAG SETZEN
              MOV  COUNT,#0
              JMP  EXITV24                  ; UND ENDE
;
;
;
ROMIMAGE      DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 006H,0EBH,0DBH,028H,001H,029H,006H,004H
              DB 0EBH,0DBH,028H,001H,04CH,06BH,03AH,027H
              DB 051H,004H,0FFH,043H,0AAH,0FFH,055H,000H
              DB 06AH,0B0H,095H,04FH,08FH,0B3H,019H,070H
              DB 0EDH,075H,0C0H,0ABH,01DH,063H,031H,094H
              DB 035H,032H,0D6H,0EBH,01BH,0A5H,0BEH,092H
              DB 0FCH,0BCH,039H,052H,012H,01FH,0B5H,0EEH
              DB 095H,0CCH,0D7H,068H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,0F1H,090H,084H
              DB 0A7H,0F5H,093H,085H,037H,0E9H,033H,086H
              DB 0BAH,02BH,013H,049H,0E9H,037H,003H,013H
              DB 007H,093H,0EDH,0E8H,037H,00DH,013H,0E8H
              DB 03BH,036H,01FH,049H,0DEH,092H,0C8H,007H
              DB 046H,005H,095H,0E5H,092H,0C7H,007H,044H
              DB 0EAH,095H,0C6H,007H,046H,005H,092H,0F1H
              DB 095H,0C5H,007H,044H,08AH,033H,08BH,03BH
              DB 092H,037H,0ADH,053H,027H,004H,027H,054H
              DB 00CH,06EH,0EEH,033H,0F6H,096H,00FH,016H
              DB 0E9H,005H,097H,08FH,00EH,064H,0EFH,079H
              DB 04DH,059H,07DH,069H,03DH,05DH,049H,06DH
              DB 039H,049H,046H,041H,03CH,039H,034H,030H
              DB 02CH,028H,024H,01DH,019H,014H,011H,00CH
              DB 009H,0EDH,007H,049H,0EDH,007H,04DH,003H
              DB 097H,0C6H,089H,03DH,0FAH,01EH,04DH,0AFH
              DB 05BH,0AEH,053H,0EEH,03BH,015H,01FH,04DH
              DB 08DH,037H,0FFH,013H,0E2H,01EH,04DH,0FAH
              DB 01EH,04DH,0AFH,05BH,0AEH,053H,092H,037H
              DB 0ADH,053H,027H,067H,009H,02FH,005H,0F6H
              DB 054H,085H,054H,010H,05BH,0D6H,084H,00BH
              DB 02DH,0B7H,06AH,0E9H,00AH,05CH,0FCH,0ABH
              DB 035H,0D6H,03FH,080H,0EDH,007H,0CDH,0CBH
              DB 01DH,049H,094H,033H,000H,0EDH,007H,04DH
              DB 0F7H,033H,0EFH,026H,089H,0BDH,02BH,013H
              DB 049H,0F6H,093H,040H,016H,0E9H,0D0H,01DH
              DB 04DH,089H,03DH,0EFH,0FAH,01EH,04DH,0A1H
              DB 01BH,005H,013H,0F0H,082H,087H,015H,090H
              DB 0F9H,093H,0EAH,0CFH,0CBH,01DH,04DH,001H
              DB 013H,040H,01BH,00DH,094H,08BH,032H,01DH
              DB 089H,039H,0FAH,01EH,04DH,0B0H,05BH,0AFH
              DB 053H,0EEH,03BH,0FDH,093H,0EAH,003H,097H
              DB 0AEH,05BH,0EEH,03BH,089H,03DH,0EFH,0ADH
              DB 053H,0EEH,03BH,023H,01FH,04DH,024H,026H
              DB 05AH,04FH,058H,00DH,049H,036H,01FH,04DH
              DB 0F0H,093H,004H,016H,0E9H,08DH,057H,0B3H
              DB 053H,004H,091H,088H,037H,0C1H,088H,033H
              DB 0EFH,0E2H,01EH,04DH,088H,037H,0ACH,01FH
              DB 04DH,0AEH,033H,08AH,0B9H,002H,091H,08BH
              DB 037H,004H,01EH,08BH,033H,036H,01FH,04DH
              DB 0F0H,093H,004H,016H,0E9H,08DH,057H,0AFH
              DB 053H,004H,091H,088H,037H,0C1H,088H,033H
              DB 0EFH,0E2H,01EH,04DH,088H,037H,0AEH,033H
              DB 0B0H,093H,0B8H,034H,089H,03DH,0B7H,03BH
              DB 0FAH,01EH,04DH,0BBH,092H,0C4H,007H,046H
              DB 005H,095H,0C2H,092H,0C3H,007H,044H,0C7H
              DB 095H,0C2H,007H,046H,005H,092H,0CEH,095H
              DB 0C1H,007H,044H,0ACH,033H,0ADH,03BH,0F7H
              DB 09AH,0EAH,0ACH,057H,0ACH,058H,0BAH,033H
              DB 00DH,01BH,0DBH,094H,08CH,003H,094H,089H
              DB 094H,0A6H,0E3H,094H,086H,0F7H,017H,049H
              DB 066H,01BH,009H,013H,088H,037H,0CFH,001H
              DB 090H,001H,013H,02BH,013H,049H,09DH,0A1H
              DB 00EH,027H,081H,0A3H,009H,018H,049H,0A7H
              DB 037H,090H,013H,004H,093H,093H,016H,094H
              DB 0A6H,002H,093H,090H,016H,028H,097H,083H
              DB 016H,022H,097H,082H,016H,022H,097H,081H
              DB 016H,021H,097H,080H,016H,0A7H,03BH,0A5H
              DB 0AFH,0FAH,093H,0EAH,0EDH,007H,04DH,040H
              DB 01BH,0E0H,095H,00FH,016H,0A9H,00EH,04DH
              DB 0ACH,053H,0EEH,03BH,092H,0BFH,08CH,03FH
              DB 004H,01BH,0EDH,007H,04DH,02FH,0EDH,007H
              DB 04DH,064H,00CH,06DH,0ACH,05BH,02FH,0EEH
              DB 03FH,0EFH,021H,097H,066H,009H,04BH,026H
              DB 093H,080H,016H,0A7H,03BH,0A9H,00EH,0CDH
              DB 0ACH,0E6H,062H,090H,09EH,037H,03FH,007H
              DB 048H,0F6H,033H,007H,08DH,083H,09EH,0B9H
              DB 061H,017H,04DH,016H,083H,08BH,09DH,0A6H
              DB 084H,0A7H,084H,0A5H,004H,093H,085H,0BAH
              DB 0E9H,0BAH,086H,03FH,0E2H,005H,04BH,00FH
              DB 097H,085H,0BDH,0E8H,0BAH,002H,097H,0E8H
              DB 0BDH,019H,090H,086H,0BAH,084H,0AEH,006H
              DB 097H,086H,0BDH,023H,09DH,087H,0F6H,033H
              DB 0FAH,01EH,049H,0AEH,05BH,0ADH,053H,027H
              DB 0A0H,007H,049H,080H,09FH,090H,0EEH,0BEH
              DB 05CH,007H,069H,088H,0B7H,091H,007H,049H
              DB 0CCH,0B2H,093H,0B1H,0ADH,065H,00EH,049H
              DB 026H,0D1H,007H,049H,045H,08FH,007H,069H
              DB 07AH,022H,099H,090H,011H,039H,009H,049H
              DB 05AH,09FH,006H,0F4H,0A8H,007H,049H,0B4H
              DB 093H,0A7H,093H,0F8H,056H,0F2H,00DH,049H
              DB 065H,0C2H,093H,011H,033H,09CH,00AH,049H
              DB 0BFH,041H,093H,03CH,04DH,092H,027H,00DH
              DB 049H,049H,006H,0CDH,001H,001H,001H,001H
              DB 002H,004H,002H,001H,005H,003H,002H,001H
              DB 005H,004H,002H,003H,0BBH,00EH,049H,0D9H
              DB 00EH,0CDH,0E7H,007H,049H,089H,039H,0EFH
              DB 0ADH,053H,0EEH,03BH,023H,01FH,04DH,0FAH
              DB 01EH,04DH,0AFH,05BH,0AEH,053H,027H,004H
              DB 090H,037H,0B0H,053H,08FH,037H,0AFH,053H
              DB 08EH,037H,0AEH,053H,08DH,037H,0ADH,053H
              DB 027H,004H,0DCH,093H,004H,016H,088H,03BH
              DB 0EEH,037H,0A6H,0A7H,0A6H,0B9H,08DH,0BCH
              DB 083H,0AFH,02CH,003H,097H,09EH,054H,0A6H
              DB 03BH,088H,03FH,0E9H,0F2H,053H,0EDH,007H
              DB 04DH,0EDH,007H,04DH,0EEH,033H,08DH,0BFH
              DB 0EFH,0EEH,0BFH,083H,0ABH,0E9H,093H,008H
              DB 016H,0E9H,0EDH,007H,04DH,05DH,00EH,063H
              DB 003H,094H,083H,055H,00EH,063H,009H,094H
              DB 089H,04DH,00EH,063H,0EFH,018H,094H,08CH
              DB 003H,094H,089H,01EH,093H,083H,014H,0A7H
              DB 033H,0F6H,093H,005H,016H,0E9H,0F2H,057H
              DB 03DH,01DH,04DH,0EFH,004H,0EEH,0BFH,0F4H
              DB 095H,00FH,016H,0E9H,0ACH,057H,0F4H,038H
              DB 0EAH,007H,04DH,0EFH,00FH,093H,080H,016H
              DB 013H,097H,066H,009H,043H,009H,097H,083H
              DB 016H,0A7H,03BH,0E9H,026H,096H,019H,0CDH
              DB 004H,0F3H,093H,0EEH,0BAH,0D6H,01CH,04DH
              DB 003H,094H,088H,0EAH,007H,04DH,00DH,097H
              DB 0EEH,0BDH,094H,0A2H,002H,093H,096H,019H
              DB 04DH,007H,093H,088H,034H,080H,011H,088H
              DB 0ADH,004H,094H,083H,0C0H,011H,0B2H,00FH
              DB 063H,088H,037H,0C0H,011H,0F2H,058H,08DH
              DB 053H,004H,01BH,002H,094H,083H,003H,01BH
              DB 0F6H,0BFH,028H,094H,08CH,055H,01CH,049H
              DB 064H,01CH,0CCH,095H,0B6H,0C2H,01CH,049H
              DB 0EEH,03FH,00FH,01BH,091H,037H,002H,094H
              DB 083H,005H,094H,08CH,004H,094H,0A6H,002H
              DB 093H,094H,014H,0A7H,033H,064H,01CH,04DH
              DB 095H,033H,094H,0A8H,002H,093H,0C0H,014H
              DB 004H,097H,060H,014H,094H,0A9H,002H,093H
              DB 0A0H,014H,0E0H,011H,094H,0ADH,094H,0ACH
              DB 02DH,02DH,02DH,087H,033H,083H,0A6H,002H
              DB 097H,008H,014H,018H,011H,087H,037H,00FH
              DB 090H,0F2H,038H,095H,033H,0FAH,024H,0F7H
              DB 01CH,0CDH,004H,083H,0A0H,002H,091H,0C1H
              DB 09CH,00FH,043H,083H,0A2H,002H,097H,08DH
              DB 051H,088H,033H,00EH,090H,083H,0A2H,004H
              DB 093H,0CDH,00FH,092H,040H,007H,044H,014H
              DB 09DH,08BH,0E9H,001H,0EEH,087H,01FH,011H
              DB 0EEH,033H,088H,037H,0BEH,01FH,04DH,007H
              DB 011H,0EEH,033H,09BH,017H,04DH,027H,0C6H
              DB 0FBH,01AH,08BH,033H,00EH,01DH,04DH,09CH
              DB 01BH,002H,0EEH,088H,0A0H,01BH,02DH,02DH
              DB 02DH,0EEH,037H,00FH,011H,0EDH,033H,009H
              DB 090H,06CH,017H,04DH,002H,01BH,0EFH,026H
              DB 05AH,0ABH,0E7H,004H,0A7H,037H,0F2H,038H
              DB 089H,039H,0FBH,093H,0EAH,0ABH,057H,004H
              DB 013H,0EEH,03FH,018H,01BH,089H,037H,0F8H
              DB 09AH,0EAH,0EBH,097H,09FH,00EH,064H,009H
              DB 01BH,0ADH,053H,027H,09DH,01EH,09DH,01FH
              DB 0E5H,095H,00FH,0EAH,007H,0CDH,004H,0F6H
              DB 093H,004H,016H,0E9H,0F2H,057H,088H,03CH
              DB 0C8H,095H,033H,0EFH,088H,037H,0ACH,01FH
              DB 04DH,093H,038H,09DH,0ABH,002H,095H,08FH
              DB 09DH,0AFH,0EAH,007H,04DH,09DH,0A8H,002H
              DB 097H,010H,015H,0D9H,010H,043H,0EDH,007H
              DB 04DH,093H,033H,0EDH,007H,04DH,09DH,033H
              DB 083H,0A1H,0ECH,024H,004H,0ABH,096H,0B6H
              DB 09AH,0B7H,004H,0ABH,09AH,0B6H,02BH,013H
              DB 049H,0E0H,090H,095H,033H,027H,095H,0B9H
              DB 002H,091H,004H,01EH,096H,033H,09AH,037H
              DB 004H,01EH,09AH,033H,097H,037H,015H,097H
              DB 004H,010H,097H,033H,094H,01FH,04DH,096H
              DB 03FH,095H,037H,030H,01BH,006H,013H,09AH
              DB 0BFH,097H,03FH,0F6H,095H,018H,016H,0E9H
              DB 0ACH,057H,03DH,01DH,04DH,0EFH,0A2H,01EH
              DB 04DH,0D0H,01DH,04DH,02BH,013H,0CCH,0A2H
              DB 01EH,0CDH,004H,08FH,057H,0C6H,08DH,057H
              DB 0ACH,053H,02BH,013H,049H,036H,01FH,04DH
              DB 008H,01DH,0EFH,0AEH,033H,00EH,01DH,04DH
              DB 0A0H,01BH,036H,01FH,04DH,013H,01DH,0E9H
              DB 016H,01DH,0EFH,0FAH,01EH,04DH,09CH,01BH
              DB 00FH,013H,09BH,017H,04DH,0EFH,013H,01FH
              DB 04DH,0ACH,01BH,00FH,013H,0F8H,093H,0EAH
              DB 02BH,093H,0ABH,00FH,063H,004H,01BH,0F6H
              DB 095H,003H,016H,0E9H,0ACH,057H,03DH,01DH
              DB 04DH,0EFH,0F6H,095H,004H,016H,0E9H,08DH
              DB 057H,03DH,01DH,04DH,0EFH,0D0H,01DH,04DH
              DB 0DBH,020H,084H,03FH,083H,0BFH,0CFH,0AEH
              DB 014H,00AH,049H,0E6H,090H,084H,0BFH,083H
              DB 03FH,0CFH,01BH,0EEH,09DH,086H,0E1H,027H
              DB 053H,0A1H,093H,0B6H,09AH,01DH,0CDH,0B5H
              DB 011H,0CDH,0ADH,015H,049H,01AH,097H,08CH
              DB 014H,013H,097H,07AH,014H,02DH,097H,086H
              DB 014H,094H,033H,092H,0BFH,0FEH,011H,049H
              DB 003H,097H,053H,014H,093H,033H,09AH,01DH
              DB 04DH,065H,01EH,04DH,0B5H,011H,04DH,0F8H
              DB 026H,05AH,0ACH,0E7H,015H,01FH,0CDH,020H
              DB 0AEH,001H,019H,049H,004H,0FBH,093H,0EAH
              DB 02DH,02DH,00DH,01BH,009H,0A0H,089H,03DH
              DB 004H,01DH,009H,0A4H,0BCH,039H,0FAH,01EH
              DB 04DH,0AEH,05BH,0ADH,053H,0EEH,03BH,0F7H
              DB 095H,010H,016H,0E9H,0BCH,057H,089H,03DH
              DB 0FAH,01EH,04DH,054H,01BH,009H,013H,01BH
              DB 020H,096H,015H,049H,008H,0A8H,04DH,006H
              DB 0CDH,004H,0E8H,093H,005H,016H,0D7H,057H
              DB 093H,0B9H,093H,03BH,0A6H,0A7H,0A6H,0B9H
              DB 09EH,053H,0A6H,03BH,0EDH,007H,04DH,0EDH
              DB 007H,04DH,093H,0BFH,0CFH,0F6H,093H,010H
              DB 016H,0E9H,0EDH,007H,04DH,0D7H,053H,0EFH
              DB 004H,0F9H,09AH,0EAH,09EH,057H,0D7H,053H
              DB 003H,01BH,00AH,01DH,00CH,01DH,00EH,01DH
              DB 093H,03FH,045H,01BH,0F2H,09AH,0EAH,0E3H
              DB 057H,0CCH,010H,063H,003H,098H,08BH,0A8H
              DB 00FH,063H,003H,01BH,0E2H,037H,0B0H,00FH
              DB 043H,0F3H,09AH,0EAH,0DEH,057H,099H,053H
              DB 002H,098H,08BH,0BCH,00FH,063H,003H,01BH
              DB 0DDH,037H,004H,013H,0F2H,09AH,0EAH,0D9H
              DB 057H,0A8H,00FH,063H,003H,098H,08BH,0CCH
              DB 010H,063H,003H,01BH,093H,037H,045H,013H
              DB 096H,0B9H,0FBH,09AH,0EAH,0D7H,0DFH,00FH
              DB 01BH,061H,017H,04DH,004H,087H,03BH,095H
              DB 033H,0A6H,037H,007H,013H,09FH,037H,08FH
              DB 01CH,09FH,03EH,02FH,09EH,037H,039H,01CH
              DB 09EH,03EH,0C2H,0A5H,03BH,0A4H,033H,0A2H
              DB 095H,006H,014H,088H,037H,002H,01EH,088H
              DB 033H,0E6H,037H,049H,01CH,0CCH,0E6H,033H
              DB 028H,0A1H,057H,0A1H,05EH,0E7H,033H,0A0H
              DB 057H,0A0H,058H,088H,03BH,0E7H,03FH,0C2H
              DB 0E7H,03BH,0E6H,038H,09FH,050H,09EH,053H
              DB 0E7H,037H,0E6H,03EH,09FH,050H,088H,03BH
              DB 041H,007H,068H,0A9H,006H,063H,027H,03DH
              DB 007H,04EH,00AH,090H,036H,007H,063H,005H
              DB 093H,0CDH,008H,095H,014H,090H,0E9H,006H
              DB 063H,027H,03EH,007H,04EH,009H,093H,002H
              DB 016H,017H,092H,008H,016H,093H,03BH,03FH
              DB 011H,09EH,053H,088H,03BH,0E6H,037H,088H
              DB 0BFH,078H,090H,09EH,057H,09EH,058H,0A6H
              DB 03BH,0A6H,0A7H,0A6H,0B9H,0ACH,01FH,04DH
              DB 000H,01CH,0C8H,095H,03CH,0C8H,0C6H,088H
              DB 03EH,081H,007H,063H,027H,00FH,011H,09EH
              DB 053H,0A6H,03BH,088H,037H,029H,007H,063H
              DB 027H,0C1H,0C1H,0C1H,0C1H,09EH,057H,09EH
              DB 058H,0A6H,03BH,032H,096H,006H,016H,004H
              DB 097H,093H,03BH,03AH,093H,096H,03BH,095H
              DB 037H,087H,03FH,03DH,01DH,04DH,02FH,00DH
              DB 049H,049H,006H,0CCH,081H,0FDH,026H,0E7H
              DB 004H,0F8H,09AH,0EAH,0EDH,007H,04DH,089H
              DB 03DH,0FFH,01EH,04DH,0ADH,05BH,027H,000H
              DB 0FFH,000H,0FFH,000H,000H,000H,000H,08DH
              DB 07FH,000H,000H,0FFH,07FH,000H,000H,0AEH
              DB 045H,00EH,0CCH,004H,006H,0A2H,00EH,0CDH
              DB 004H,0FBH,093H,0EAH,039H,01DH,0ADH,05BH
              DB 0EEH,03BH,089H,03DH,0EFH,0FFH,01EH,04DH
              DB 011H,00EH,0CDH,0D0H,01DH,049H,060H,013H
              DB 004H,09DH,0A2H,008H,022H,0F6H,083H,004H
              DB 02FH,083H,037H,083H,038H,040H,013H,039H
              DB 0FDH,00EH,036H,0A2H,090H,099H,050H,009H
              DB 042H,049H,061H,026H,067H,052H,070H,020H
              DB 067H,094H,0E9H,0A5H,00DH,039H,0B0H,097H
              DB 091H,0A4H,053H,0A1H,038H,005H,0BBH,094H
              DB 09EH,0CDH,09BH,0A1H,0AFH,04AH,04AH,043H
              DB 03CH,067H,097H,005H,010H,0E4H,08DH,092H
              DB 01FH,0F5H,092H,078H,0D1H,040H,09EH,0C1H
              DB 0A7H,03DH,038H,04AH,084H,0E0H,01EH,051H
              DB 0F6H,0B9H,0DCH,031H,074H,005H,032H,0B3H
              DB 05CH,0B0H,09BH,000H,000H,000H,000H,00FH
              DB 055H,000H,000H,0EBH,0DBH,028H,001H,060H
              DB 0E2H,09DH,046H,051H,028H,030H,007H,009H
              DB 0DCH,0B5H,02BH,0C3H,0AFH,0BCH,06CH,08EH
              DB 063H,08FH,0F4H,0B3H,0CAH,082H,0EAH,061H
              DB 0C1H,052H,0CCH,01EH,078H,02EH,0ACH,0DBH
              DB 02FH,0D0H,05DH,04BH,0E6H,05FH,08DH,086H
              DB 024H,028H,032H,0DFH,009H,09BH,037H,0B2H
              DB 0B6H,04CH,0A3H,070H,0C3H,044H,0D8H,0B7H
              DB 0BFH,0C6H,026H,06EH,08BH,0DDH,049H,0A4H
              DB 0F2H,047H,072H,09BH,036H,06FH,08FH,043H
              DB 082H,0CDH,008H,0E1H,0E8H,0AAH,02AH,063H
              DB 0C1H,0F7H,027H,0D8H,0E5H,003H,030H,002H
              DB 04FH,0B1H,0E2H,0FFH,0C5H,023H,082H,0F3H
              DB 05FH,061H,05CH,053H,0C6H,043H,025H,074H
              DB 0AFH,09DH,08FH,055H,095H,0ABH,02CH,0ABH
              DB 0B5H,0BEH,087H,02CH,04DH,027H,07EH,01FH
              DB 017H,062H,0E4H,023H,002H,085H,056H,03EH
              DB 032H,0E9H,05CH,027H,039H,018H,0C3H,0D7H
              DB 095H,0F9H,038H,053H,09DH,061H,091H,081H
              DB 0B0H,0B7H,050H,018H,0CDH,081H,080H,0BEH
              DB 087H,0B6H,08CH,0E7H,08CH,0E8H,0A5H,0BEH
              DB 0A5H,017H,0A5H,03CH,02DH,01EH,0CDH,000H
              DB 0A9H,048H,087H,0B9H,048H,043H,081H,0BBH
              DB 0B8H,010H,0D6H,097H,0B1H,0BBH,00FH,0A4H
              DB 08CH,0E6H,0A5H,0BEH,081H,0B7H,0A8H,010H
              DB 0D6H,097H,0B1H,0BBH,044H,044H,044H,044H
              DB 08CH,0E7H,08CH,0E8H,0A5H,0BEH,087H,0B7H
              DB 080H,0BFH,050H,018H,0CDH,081H,0B5H,0B7H
              DB 0A5H,017H,0A5H,03CH,0B4H,015H,002H,027H
              DB 08CH,0E1H,0A5H,0BEH,050H,018H,0CDH,015H
              DB 0ADH,017H,0ADH,0B5H,0B6H,0B5H,03FH,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 018H,000H,020H,037H,037H,037H,034H,038H
              DB 034H,020H,036H,030H,035H,030H,020H,04CH
              DB 04CH,041H,043H,020H,045H,053H,041H,045H
              DB 04CH,050H,018H,081H,0B8H,00CH,0A3H,019H
              DB 008H,019H,0CCH,00BH,06BH,00BH,0ADH,00BH
              DB 054H,08BH,0B0H,09CH,0ABH,09CH,0EAH,09FH
              DB 01BH,08BH,0C2H,08AH,074H,097H,06BH,097H
              DB 0B8H,08AH,05EH,00AH,065H,019H,090H,019H
              DB 052H,017H,0EAH,007H,049H,020H,020H,000H
              DB 000H,000H,021H,006H,000H,000H,000H,000H
              DB 04FH,095H,08DH,000H,032H,030H,0D9H,021H
              DB 0CBH,0DFH,014H,0C5H,0ACH,08FH,09AH,03CH
              DB 0B7H,0E2H,03CH,0CBH,0AAH,01FH,0E3H,004H
              DB 040H,093H,067H,0A8H,0A2H,0BAH,01BH,0B4H
              DB 057H,0C2H,028H,0CDH,0FAH,03AH,081H,01CH
              DB 092H,0EDH,0C1H,019H,000H,0A9H,039H,079H
              DB 032H,0EEH,051H,08DH,0C6H,02BH,029H,075H
              DB 070H,0E0H,01FH,004H,0EAH,091H,02EH,000H
              DB 059H,04DH,000H,000H,000H,009H,04BH,053H
              DB 0B0H,03EH,00EH,049H,01DH,011H,049H,02BH
              DB 013H,049H,046H,013H,049H,010H,00EH,049H
              DB 010H,00EH,049H,071H,009H,049H,032H,009H
              DB 049H,0ABH,014H,049H,0CFH,014H,049H,093H
              DB 014H,049H,0BFH,013H,049H,0FFH,01CH,049H
              DB 02CH,019H,049H,0DFH,00EH,049H,0ACH,008H
              DB 049H,027H,01BH,049H,0A2H,01AH,049H,097H
              DB 01AH,049H,011H,012H,070H,011H,015H,006H
              DB 015H,006H,0ABH,011H,093H,011H,07FH,011H
              DB 062H,011H,053H,011H,02FH,006H,030H,011H
              DB 015H,011H,000H,011H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,0FCH,090H,02DH,02DH
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 01DH,011H,094H,005H,091H,005H,021H,06AH
              DB 043H,0DEH,044H,0BFH,004H,0C1H,0C1H,0C1H
              DB 0B0H,00FH,043H,004H,08EH,037H,0DBH,011H
              DB 049H,008H,0AFH,009H,018H,049H,008H,0AFH
              DB 004H,08BH,037H,08AH,0B9H,002H,091H,004H
              DB 01EH,08BH,033H,0D0H,01DH,049H,060H,013H
              DB 00FH,093H,00FH,011H,08BH,033H,0F7H,090H
              DB 0EAH,000H,01CH,0C8H,0F9H,097H,0EDH,001H
              DB 013H,027H,004H,0FBH,09AH,0EAH,0ACH,0DFH
              DB 03FH,01BH,004H,000H,01CH,0C8H,000H,01DH
              DB 002H,01DH,004H,01DH,004H,008H,0ABH,055H
              DB 012H,04DH,008H,0AFH,004H,008H,0AFH,0B7H
              DB 015H,04DH,008H,0ABH,004H,008H,0AFH,02FH
              DB 015H,04DH,008H,0ABH,004H,008H,0AFH,0D2H
              DB 015H,04DH,008H,0ABH,004H,008H,0AFH,04AH
              DB 015H,04DH,008H,0ABH,004H,008H,0AFH,03BH
              DB 016H,04DH,008H,0ABH,02DH,02DH,02DH,02DH
              DB 02DH,02DH,02DH,02DH,0CCH,090H,009H,0AFH
              DB 08AH,01DH,0F6H,090H,02CH,091H,03BH,004H
              DB 009H,0A0H,009H,0A2H,028H,0F4H,093H,0EAH
              DB 0CAH,01DH,04DH,0B9H,01DH,04DH,00FH,009H
              DB 081H,092H,03BH,0FDH,093H,0EAH,0EFH,009H
              DB 0A6H,0F9H,09AH,0EAH,089H,03DH,08DH,053H
              DB 003H,01BH,009H,0A4H,009H,0A2H,0E1H,01DH
              DB 009H,0ABH,02AH,095H,034H,01DH,004H,097H
              DB 0CCH,01DH,08DH,057H,091H,03BH,088H,033H
              DB 0A2H,01DH,02FH,0CDH,01DH,00FH,013H,088H
              DB 037H,0DAH,090H,067H,013H,004H,0F7H,09AH
              DB 0EAH,04CH,093H,08DH,054H,089H,03DH,0DDH
              DB 01DH,01FH,01DH,0E5H,01DH,004H,0EFH,0F5H
              DB 09AH,0EAH,004H,093H,08DH,054H,08DH,05AH
              DB 089H,03DH,0F0H,01DH,004H,089H,037H,063H
              DB 013H,0EFH,08BH,03FH,08AH,037H,005H,090H
              DB 003H,01BH,004H,0EFH,09AH,0EAH,08DH,057H
              DB 08DH,05AH,0F0H,011H,089H,03DH,08DH,057H
              DB 00FH,011H,089H,03DH,012H,01DH,08BH,0A6H
              DB 08BH,0A4H,091H,037H,003H,011H,08BH,037H
              DB 08AH,0B9H,002H,091H,08BH,03EH,004H,000H
              DB 0A4H,004H,0A0H,02DH,088H,0BAH,088H,0B9H
              DB 0B8H,01DH,04DH,0B9H,01DH,04DH,02DH,02DH
              DB 0BAH,01DH,04DH,0B6H,01DH,04DH,0B6H,01DH
              DB 04DH,0B6H,01DH,04DH,00EH,082H,089H,017H
              DB 082H,08BH,02DH,02DH,02DH,000H,088H,080H
              DB 000H,088H,080H,000H,088H,080H,08EH,090H
              DB 000H,0A4H,0D0H,01DH,049H,0B7H,01DH,04DH
              DB 0B2H,01DH,04DH,0B9H,01DH,04DH,0B5H,01DH
              DB 04DH,0B9H,01DH,04DH,0B5H,01DH,04DH,00CH
              DB 082H,089H,012H,082H,08BH,08EH,090H,02DH
              DB 000H,0A4H,02DH,0C6H,01DH,04DH,004H,082H
              DB 08BH,02DH,004H,088H,033H,0FDH,09AH,0CAH
              DB 00FH,011H,0C0H,0D1H,010H,043H,088H,037H
              DB 00DH,082H,08EH,082H,0A5H,012H,082H,085H
              DB 023H,000H,084H,0C5H,01DH,04DH,0B9H,01DH
              DB 04DH,0B9H,01DH,04DH,0B5H,01DH,04DH,006H
              DB 082H,089H,00CH,082H,08BH,088H,033H,087H
              DB 03BH,004H,0A4H,000H,0A0H,0CDH,083H,01DH
              DB 084H,01DH,087H,01DH,0B8H,01DH,04DH,0B8H
              DB 01DH,04DH,00AH,082H,08BH,009H,082H,089H
              DB 0CDH,000H,0A0H,071H,082H,080H,09CH,01DH
              DB 02DH,003H,082H,08BH,0E0H,093H,0EAH,0CCH
              DB 09EH,01DH,09BH,01DH,09CH,01DH,006H,082H
              DB 08BH,02DH,008H,082H,089H,082H,0A6H,082H
              DB 0B9H,000H,0A0H,02DH,0BAH,01DH,003H,082H
              DB 08BH,02DH,070H,095H,02CH,004H,0A0H,000H
              DB 0A0H,009H,01BH,082H,0A4H,0EFH,093H,0EAH
              DB 0C9H,01DH,0C3H,01DH,0C5H,01DH,0C3H,01DH
              DB 004H,082H,089H,009H,082H,08BH,011H,097H
              DB 0D8H,010H,04BH,0FDH,000H,084H,004H,0A4H
              DB 0B9H,01DH,04DH,0B5H,01DH,04DH,006H,082H
              DB 089H,009H,082H,08BH,087H,03FH,088H,037H
              DB 065H,01EH,04DH,082H,0A1H,004H,0CDH,02DH
              DB 0CDH,02DH,0CDH,02DH,02DH,0CDH,0CDH,0CDH
              DB 004H,090H,004H,090H,02DH,02DH,0CDH,02DH
              DB 02DH,02DH,0CDH,004H,090H,02DH,004H,088H
              DB 0BAH,088H,0B9H,00BH,01DH,00DH,01DH,02DH
              DB 012H,01DH,010H,01DH,012H,01DH,014H,01DH
              DB 009H,082H,089H,010H,082H,08BH,0ECH,090H
              DB 02DH,028H,001H,0A4H,004H,0C6H,001H,0A0H
              DB 086H,082H,084H,087H,03BH,0E1H,093H,0EAH
              DB 082H,0A6H,082H,0B9H,02CH,001H,0A0H,013H
              DB 000H,084H,044H,01DH,03CH,01DH,03EH,01DH
              DB 006H,082H,08BH,007H,082H,089H,055H,01DH
              DB 002H,082H,08BH,0CCH,05BH,01DH,04DH,01DH
              DB 002H,082H,089H,0CDH,065H,01DH,008H,082H
              DB 08BH,0F4H,000H,080H,009H,01BH,001H,0A0H
              DB 082H,0A6H,0FDH,000H,080H,0FDH,000H,084H
              DB 001H,0A4H,004H,0A4H,000H,0A0H,004H,0A0H
              DB 0D1H,010H,04BH,087H,03FH,082H,0A4H,005H
              DB 0A0H,001H,0A0H,0C9H,01DH,04DH,0BBH,01DH
              DB 04DH,001H,0A0H,0B9H,01DH,04DH,0B5H,01DH
              DB 04DH,006H,082H,089H,00EH,082H,08BH,000H
              DB 0A4H,004H,0A0H,0B9H,01DH,04DH,0B9H,01DH
              DB 04DH,0B5H,01DH,04DH,006H,082H,089H,00CH
              DB 082H,08BH,0E2H,01EH,049H,0FAH,01EH,04DH
              DB 00FH,013H,027H,0C0H,01EH,004H,004H,015H
              DB 0D9H,010H,043H,004H,07CH,013H,063H,0A1H
              DB 03BH,070H,005H,049H,004H,0C1H,09CH,00FH
              DB 043H,004H,094H,0A2H,002H,093H,096H,019H
              DB 04DH,0F6H,0BFH,005H,01BH,091H,037H,097H
              DB 0BFH,00FH,091H,090H,0B9H,004H,092H,091H
              DB 034H,0ECH,094H,087H,0C9H,094H,08EH,003H
              DB 09DH,08CH,004H,094H,0A2H,002H,097H,09CH
              DB 031H,006H,093H,09BH,0BAH,01CH,094H,083H
              DB 01FH,094H,08EH,003H,09DH,08CH,004H,09CH
              DB 0BFH,002H,097H,096H,019H,04DH,004H,01BH
              DB 090H,037H,0F5H,0BFH,0F5H,038H,097H,0B9H
              DB 004H,08FH,037H,097H,0B9H,005H,097H,080H
              DB 03FH,097H,082H,004H,09CH,037H,0BEH,01FH
              DB 04DH,007H,011H,02FH,09BH,037H,0C9H,0C1H
              DB 0C1H,0C1H,07FH,011H,027H,0F5H,038H,0B6H
              DB 00FH,043H,016H,09EH,0B6H,00FH,048H,0C8H
              DB 09CH,0BFH,0F2H,0BFH,08DH,03FH,0B2H,00FH
              DB 04BH,094H,0AEH,002H,097H,020H,015H,006H
              DB 09DH,08CH,094H,0A2H,00BH,093H,0C6H,094H
              DB 0A3H,010H,09AH,00CH,09AH,002H,09DH,08CH
              DB 0F2H,038H,094H,0A6H,004H,0F6H,093H,0EEH
              DB 0BAH,0D6H,01CH,04DH,0EBH,005H,04DH,0EEH
              DB 03FH,00FH,01BH,02BH,013H,049H,0ADH,014H
              DB 049H,003H,084H,08BH,085H,0BFH,0EFH,094H
              DB 083H,005H,09AH,0D9H,010H,043H,0CBH,01DH
              DB 049H,0FAH,094H,083H,095H,0B9H,004H,009H
              DB 094H,080H,008H,0AFH,0B3H,093H,089H,03DH
              DB 0E9H,0C7H,093H,097H,0BAH,00FH,01DH,002H
              DB 095H,0C0H,014H,004H,095H,0B0H,014H,00AH
              DB 097H,0CDH,00DH,090H,0F4H,093H,099H,0BAH
              DB 0CBH,01DH,04DH,003H,094H,083H,095H,0B9H
              DB 020H,013H,099H,037H,00FH,011H,01FH,095H
              DB 0B0H,014H,025H,095H,020H,014H,029H,091H
              DB 0C0H,014H,02BH,097H,022H,084H,08BH,089H
              DB 03DH,0E9H,039H,097H,097H,037H,089H,03DH
              DB 08AH,0B9H,002H,091H,08BH,037H,08BH,03EH
              DB 0EFH,0CFH,0FAH,01EH,04DH,045H,005H,06BH
              DB 044H,005H,063H,094H,0A8H,002H,096H,084H
              DB 096H,0B1H,018H,01BH,004H,083H,08AH,014H
              DB 01BH,009H,083H,088H,096H,0B1H,012H,01BH
              DB 010H,083H,08DH,096H,0B1H,00AH,01BH,01CH
              DB 084H,082H,00EH,01BH,005H,093H,004H,015H
              DB 020H,083H,086H,096H,0B1H,008H,01BH,027H
              DB 083H,085H,096H,0B1H,016H,01BH,02EH,083H
              DB 084H,096H,0B1H,006H,01BH,03AH,083H,08FH
              DB 00CH,01BH,03AH,083H,087H,096H,0B1H,002H
              DB 01BH,046H,084H,088H,004H,01BH,04BH,084H
              DB 081H,010H,01BH,04BH,084H,080H,00DH,093H
              DB 004H,015H,0D9H,010H,043H,055H,091H,0EDH
              DB 01FH,04DH,0EFH,096H,037H,0E1H,005H,043H
              DB 094H,0ACH,008H,0ABH,0E4H,01AH,049H,02DH
              DB 01FH,04DH,088H,037H,010H,018H,089H,03DH
              DB 0E9H,0F4H,09AH,088H,0BAH,0F8H,097H,094H
              DB 01AH,04DH,013H,097H,0EDH,0E8H,0E8H,005H
              DB 04BH,088H,037H,01FH,011H,085H,033H,0FAH
              DB 01EH,04DH,00FH,013H,0B8H,01BH,09AH,094H
              DB 083H,087H,086H,082H,086H,097H,03FH,014H
              DB 0E2H,097H,03EH,014H,038H,092H,05FH,014H
              DB 08BH,097H,03DH,014H,040H,096H,03CH,014H
              DB 044H,097H,085H,033H,048H,09AH,0D9H,010H
              DB 043H,061H,005H,049H,086H,0A2H,042H,01CH
              DB 049H,0DDH,093H,0EDH,0A6H,0B9H,03AH,01CH
              DB 04DH,0B8H,00FH,063H,03AH,01CH,04DH,0B9H
              DB 00FH,061H,00FH,01AH,0F0H,097H,0B9H,00FH
              DB 061H,005H,09AH,093H,033H,019H,097H,093H
              DB 01DH,020H,097H,0EDH,0E8H,0E8H,005H,04BH
              DB 03AH,01CH,04DH,0E7H,005H,04AH,0A6H,0BFH
              DB 0A6H,033H,03AH,01CH,04DH,0E6H,005H,043H
              DB 093H,037H,010H,013H,03EH,093H,043H,014H
              DB 085H,033H,02BH,01FH,04DH,0CAH,01BH,010H
              DB 013H,088H,037H,085H,033H,086H,0A6H,00FH
              DB 094H,083H,0F6H,090H,0F0H,013H,01EH,090H
              DB 086H,0A6H,093H,037H,0CFH,05CH,090H,0F2H
              DB 093H,004H,016H,0E9H,03AH,01CH,04DH,0C9H
              DB 001H,093H,093H,036H,0CFH,0EFH,093H,037H
              DB 007H,011H,0CAH,010H,043H,03AH,01CH,04DH
              DB 044H,013H,03AH,01CH,04DH,0CFH,004H,0B8H
              DB 00FH,063H,003H,093H,0B9H,00FH,063H,0EAH
              DB 0EAH,05EH,005H,049H,064H,005H,049H,095H
              DB 0BFH,094H,0A0H,094H,0A7H,0D0H,01DH,04DH
              DB 095H,03AH,060H,013H,002H,094H,08CH,080H
              DB 013H,007H,09DH,087H,0CFH,093H,037H,095H
              DB 030H,018H,013H,01AH,01DH,094H,0A3H,01EH
              DB 090H,094H,0A0H,094H,0A7H,006H,084H,08FH
              DB 004H,0F6H,093H,003H,016H,0E9H,0D0H,01DH
              DB 04DH,09FH,053H,0EFH,088H,018H,04DH,09EH
              DB 01BH,09EH,037H,082H,090H,003H,013H,002H
              DB 097H,085H,00DH,013H,01BH,084H,08FH,00CH
              DB 01DH,02FH,08FH,01DH,093H,01DH,054H,013H
              DB 027H,0CAH,0A0H,097H,0C9H,090H,030H,08FH
              DB 033H,09EH,01DH,0A0H,01DH,022H,01DH,08DH
              DB 033H,0A8H,01DH,001H,013H,002H,084H,08BH
              DB 020H,013H,0B1H,01DH,050H,013H,0B5H,01DH
              DB 0C4H,013H,004H,084H,08FH,00BH,01DH,04DH
              DB 02BH,013H,049H,003H,01DH,097H,037H,004H
              DB 01EH,097H,033H,00BH,01DH,097H,037H,0C8H
              DB 0C8H,0C8H,085H,030H,0C1H,0E4H,005H,043H
              DB 0D7H,01DH,002H,084H,08BH,06DH,084H,087H
              DB 070H,09DH,087H,098H,013H,068H,01AH,049H
              DB 003H,097H,005H,01DH,04DH,004H,05FH,084H
              DB 08BH,0EEH,01DH,0DFH,014H,04DH,0DAH,01BH
              DB 019H,013H,044H,049H,041H,050H,0CBH,01DH
              DB 049H,020H,013H,004H,083H,0A1H,002H,097H
              DB 08DH,051H,087H,03BH,0BEH,01FH,04DH,007H
              DB 011H,0CAH,0E5H,005H,043H,087H,037H,0C1H
              DB 0C1H,0C1H,0CAH,017H,097H,0E5H,005H,043H
              DB 004H,090H,037H,08FH,037H,08EH,037H,08DH
              DB 037H,004H,083H,037H,083H,03AH,0C6H,097H
              DB 005H,043H,008H,09DH,08AH,004H,0F4H,093H
              DB 0EAH,003H,093H,0B1H,00FH,064H,0F1H,058H
              DB 08CH,053H,004H,09DH,037H,03DH,01DH,04DH
              DB 004H,083H,0A3H,002H,091H,0A7H,00FH,044H
              DB 096H,03FH,0EAH,005H,04BH,003H,095H,0A5H
              DB 00FH,044H,0E9H,005H,04BH,00BH,095H,0A4H
              DB 00FH,044H,0EFH,093H,037H,0A5H,01EH,04DH
              DB 003H,093H,086H,03DH,01DH,04DH,093H,037H
              DB 0D4H,010H,043H,004H,0D1H,09AH,004H,010H
              DB 0C0H,010H,08BH,033H,084H,0A2H,084H,0AAH
              DB 004H,084H,088H,007H,084H,080H,00AH,095H
              DB 0F1H,034H,091H,037H,006H,095H,091H,03EH
              DB 090H,030H,0D0H,097H,08EH,036H,0F0H,03BH
              DB 0CAH,0D7H,097H,0C9H,08FH,033H,026H,093H
              DB 044H,017H,04DH,0C8H,0C8H,0E4H,005H,043H
              DB 091H,0BFH,084H,0A6H,0EAH,097H,0F1H,0BDH
              DB 0F0H,083H,08FH,0F3H,083H,087H,0F6H,091H
              DB 0F7H,01CH,04DH,083H,0A2H,004H,084H,0A6H
              DB 083H,0A9H,002H,092H,080H,034H,0E0H,011H
              DB 0F1H,033H,00DH,09DH,08BH,059H,09DH,087H
              DB 0ADH,014H,049H,0D4H,090H,0F2H,093H,008H
              DB 016H,0E9H,007H,097H,097H,0BAH,0D0H,01DH
              DB 04DH,09EH,053H,0EFH,0E7H,099H,087H,099H
              DB 0B9H,095H,0B9H,09EH,057H,099H,03BH,088H
              DB 03AH,0F0H,011H,089H,03DH,088H,037H,00FH
              DB 011H,089H,03DH,095H,03BH,099H,0BFH,095H
              DB 03FH,0E9H,097H,037H,031H,097H,089H,03DH
              DB 093H,037H,0C0H,097H,030H,089H,03DH,0FAH
              DB 01EH,04DH,00FH,013H,0F4H,090H,099H,0B9H
              DB 077H,091H,030H,0F8H,095H,091H,034H,073H
              DB 099H,0BFH,004H,030H,01AH,099H,033H,005H
              DB 01DH,091H,037H,004H,0F1H,093H,099H,0BAH
              DB 0E9H,001H,057H,020H,013H,009H,093H,030H
              DB 014H,001H,053H,099H,037H,002H,013H,003H
              DB 057H,030H,01AH,073H,002H,057H,01BH,01DH
              DB 00AH,013H,001H,057H,021H,01DH,064H,013H
              DB 036H,01FH,049H,08DH,03FH,08FH,037H,0A7H
              DB 0ACH,002H,092H,08FH,034H,090H,033H,002H
              DB 091H,090H,034H,006H,090H,090H,0BFH,08EH
              DB 0BFH,006H,097H,08DH,036H,0ECH,03BH,0CAH
              DB 090H,0BFH,002H,093H,0C9H,0EDH,033H,00BH
              DB 01DH,04DH,0C8H,0C8H,083H,091H,0E4H,005H
              DB 044H,00FH,011H,0A7H,033H,02FH,017H,049H
              DB 0AEH,0A7H,08CH,09DH,0A1H,0B3H,095H,00AH
              DB 01DH,0BAH,01DH,0EFH,090H,088H,03AH,08DH
              DB 053H,0C2H,01DH,0BDH,090H,04AH,01DH,08FH
              DB 057H,0C6H,08DH,057H,088H,031H,088H,0B6H
              DB 08DH,053H,00FH,0A7H,08AH,078H,017H,04DH
              DB 0EEH,037H,0A7H,033H,021H,0A7H,089H,0CEH
              DB 090H,00FH,013H,0A7H,01BH,0D0H,0A7H,084H
              DB 088H,037H,0ECH,033H,0B8H,0A7H,08DH,010H
              DB 0A7H,08FH,0D3H,094H,086H,005H,013H,004H
              DB 0D7H,095H,0D0H,010H,044H,093H,033H,02BH
              DB 013H,049H,09DH,0A1H,002H,095H,02BH,01FH
              DB 04DH,005H,013H,0EFH,008H,082H,088H,006H
              DB 090H,010H,013H,0D0H,01BH,088H,037H,02FH
              DB 009H,096H,0D0H,010H,046H,093H,03BH,094H
              DB 0A6H,083H,0A8H,083H,0AEH,004H,0A7H,080H
              DB 083H,0AAH,009H,0A7H,082H,083H,0AEH,083H
              DB 0ACH,0E5H,0A7H,081H,023H,090H,0A6H,01BH
              DB 00FH,013H,080H,037H,0ACH,01FH,04DH,0ECH
              DB 033H,00BH,0A7H,080H,0E5H,01BH,005H,013H
              DB 088H,037H,0ECH,033H,0FBH,090H,0D0H,01DH
              DB 04DH,069H,013H,00FH,011H,04DH,018H,013H
              DB 04DH,0F3H,097H,0C9H,09EH,00FH,068H,09CH
              DB 00FH,063H,0E9H,001H,01DH,004H,0E9H,001H
              DB 0EEH,087H,01FH,011H,0EEH,033H,088H,037H
              DB 0BEH,01FH,04DH,01FH,011H,0EEH,033H,012H
              DB 01DH,027H,004H,011H,08BH,033H,00EH,01DH
              DB 04DH,09CH,01BH,002H,0EEH,088H,0A0H,01BH
              DB 0F4H,090H,001H,01BH,004H,0EFH,057H,002H
              DB 09DH,087H,0ECH,057H,0EFH,004H,0A6H,0BFH
              DB 0FBH,09AH,0EAH,09EH,0DFH,007H,01BH,004H
              DB 0D0H,01DH,04DH,094H,033H,006H,01DH,083H
              DB 037H,083H,031H,097H,005H,043H,004H,0CFH
              DB 00BH,01DH,04DH,004H,093H,02FH,0EFH,034H
              DB 0C0H,00FH,063H,027H,06AH,005H,049H,084H
              DB 0A6H,084H,0A3H,086H,03FH,0E9H,001H,093H
              DB 0E2H,005H,04BH,085H,03FH,0E1H,0E4H,005H
              DB 04BH,083H,0A9H,0D4H,093H,0F1H,0BDH,004H
              DB 010H,0C0H,010H,08BH,033H,036H,01FH,04DH
              DB 090H,037H,0F1H,0BFH,090H,03EH,0F1H,033H
              DB 006H,090H,08FH,033H,0F1H,037H,0C0H,007H
              DB 091H,0F1H,030H,090H,030H,08FH,033H,08EH
              DB 037H,0F0H,033H,022H,093H,041H,01DH,0C8H
              DB 0C8H,0E4H,005H,043H,045H,084H,086H,06DH
              DB 005H,04DH,04BH,084H,08EH,03CH,084H,086H
              DB 04FH,090H,084H,0A0H,0ABH,037H,002H,013H
              DB 008H,084H,085H,02BH,013H,049H,0EBH,011H
              DB 083H,033H,004H,093H,085H,037H,02FH,009H
              DB 09AH,0D9H,010H,043H,011H,097H,005H,01DH
              DB 04DH,027H,03DH,01DH,04DH,0DBH,090H,089H
              DB 03DH,095H,033H,089H,037H,049H,013H,0FAH
              DB 01EH,04DH,0EDH,005H,06BH,099H,03FH,0E9H
              DB 0E9H,07FH,011H,0EEH,005H,063H,099H,03BH
              DB 0EBH,005H,04DH,003H,09AH,0EEH,005H,06BH
              DB 099H,03BH,099H,0BFH,0F0H,090H,0FAH,093H
              DB 0EAH,0D0H,01FH,04DH,0F8H,097H,0E3H,005H
              DB 04BH,02BH,013H,049H,082H,0A3H,005H,097H
              DB 0CDH,082H,0A7H,03DH,01DH,04DH,00AH,090H
              DB 0CBH,01DH,04DH,0F0H,033H,005H,0A6H,08FH
              DB 0EDH,093H,099H,0BAH,0E9H,0CBH,01DH,04DH
              DB 000H,010H,068H,003H,084H,08DH,006H,0A6H
              DB 086H,09EH,053H,0EFH,0A6H,037H,0D9H,010H
              DB 043H,099H,03FH,008H,01BH,061H,017H,04DH
              DB 003H,097H,0C6H,083H,03AH,097H,005H,043H
              DB 008H,09DH,085H,00BH,091H,0EDH,01FH,04DH
              DB 02BH,013H,049H,0D0H,01DH,04DH,095H,033H
              DB 0D0H,01DH,04DH,087H,013H,002H,090H,0F0H
              DB 013H,006H,097H,03FH,016H,00AH,097H,03DH
              DB 016H,00CH,097H,03CH,016H,086H,0A4H,012H
              DB 097H,03BH,016H,086H,0A0H,0F1H,013H,01AH
              DB 097H,085H,03BH,01EH,09AH,0D9H,010H,043H
              DB 08FH,01AH,04DH,094H,0A3H,028H,090H,095H
              DB 037H,01CH,013H,006H,084H,087H,009H,09DH
              DB 087H,00CH,093H,005H,01DH,04DH,0EEH,011H
              DB 049H,07CH,01FH,04DH,02BH,013H,049H,0CBH
              DB 01DH,04DH,083H,033H,0CBH,016H,049H,085H
              DB 005H,049H,088H,005H,049H,05DH,013H,049H
              DB 05AH,014H,049H,0EBH,019H,049H,0EAH,015H
              DB 069H,0C6H,015H,06BH,097H,033H,0D0H,01DH
              DB 04DH,09AH,01DH,04DH,082H,0A1H,002H,092H
              DB 008H,016H,00CH,096H,002H,016H,012H,020H
              DB 0A0H,00FH,006H,003H,000H,066H,01AH,009H
              DB 00CH,0BAH,08AH,088H,080H,076H,072H,07CH
              DB 07AH,078H,070H,082H,07EH,074H,0FEH,011H
              DB 049H,0F8H,09AH,0EAH,01EH,097H,0BAH,015H
              DB 064H,00BH,01BH,0AEH,011H,049H,084H,0ABH
              DB 002H,09AH,0A0H,005H,043H,084H,0AFH,080H
              DB 037H,080H,03AH,0C8H,0ACH,01FH,04DH,0A6H
              DB 00FH,043H,06EH,01FH,049H,00FH,013H,027H
              DB 004H,01EH,08BH,033H,004H,01DH,0C0H,01EH
              DB 0CFH,004H,08EH,057H,0E1H,0C3H,00FH,060H
              DB 0C2H,00FH,063H,0E8H,08DH,057H,0E1H,0C0H
              DB 00FH,063H,02BH,013H,049H,09AH,037H,0EEH
              DB 033H,07CH,005H,049H,003H,097H,010H,010H
              DB 097H,033H,0F6H,093H,099H,0BAH,0E9H,0CBH
              DB 01DH,04DH,09EH,053H,0EFH,099H,03FH,006H
              DB 01BH,0A3H,0BFH,0A2H,0BFH,083H,01DH,08EH
              DB 01DH,0BCH,01BH,00FH,013H,088H,01DH,004H
              DB 013H,084H,0A8H,067H,005H,04DH,098H,0ABH
              DB 07CH,014H,049H,003H,098H,08CH,098H,0ACH
              DB 013H,01FH,04DH,0B8H,01BH,00FH,013H,0F8H
              DB 093H,0EAH,08CH,057H,0CBH,010H,063H,004H
              DB 01BH,0EEH,090H,002H,097H,08BH,036H,0C4H
              DB 01BH,036H,01FH,04DH,090H,037H,08FH,033H
              DB 00EH,01DH,04DH,0C0H,01BH,036H,01FH,04DH
              DB 066H,01DH,004H,01BH,06AH,01DH,0F9H,093H
              DB 0EAH,00CH,093H,08CH,0DDH,004H,01BH,010H
              DB 01DH,04DH,0BCH,01BH,00FH,013H,0F8H,093H
              DB 0EAH,043H,093H,0B7H,00FH,063H,004H,01BH
              DB 08CH,098H,087H,004H,0F7H,093H,004H,016H
              DB 0E9H,0ECH,01DH,08DH,053H,0EFH,010H,01DH
              DB 04DH,00FH,013H,0A8H,01BH,0F8H,01DH,0B0H
              DB 00FH,043H,0CBH,01DH,049H,0D8H,090H,006H
              DB 01EH,079H,005H,049H,003H,097H,010H,010H
              DB 097H,033H,010H,01DH,0FBH,093H,0EAH,012H
              DB 01DH,005H,01BH,002H,013H,02BH,013H,049H
              DB 0FAH,093H,093H,0BAH,01FH,01DH,0CFH,007H
              DB 097H,093H,033H,093H,037H,097H,033H,004H
              DB 0BDH,00FH,06AH,0E1H,0C3H,00FH,060H,0C2H
              DB 00FH,063H,004H,01BH,00CH,093H,004H,01DH
              DB 0EFH,014H,090H,005H,01EH,076H,005H,049H
              DB 003H,097H,010H,010H,097H,033H,049H,01DH
              DB 00FH,01DH,050H,01DH,059H,01DH,0ACH,01BH
              DB 053H,01DH,001H,013H,071H,0ABH,081H,042H
              DB 0ABH,082H,006H,093H,005H,01DH,04DH,038H
              DB 091H,0F7H,01CH,04DH,03DH,091H,0EDH,01FH
              DB 04DH,09DH,0A3H,002H,097H,040H,015H,0D9H
              DB 010H,043H,0EEH,037H,09AH,033H,053H,018H
              DB 049H,09AH,0BFH,0EDH,037H,09AH,053H,0ECH
              DB 037H,099H,053H,0ABH,090H,0ABH,0BFH,004H
              DB 01DH,002H,01BH,0A7H,0B9H,00AH,01DH,0EFH
              DB 0A7H,037H,044H,013H,0F7H,093H,0EAH,0D1H
              DB 093H,09DH,054H,0F1H,053H,004H,01BH,067H
              DB 005H,04DH,0DCH,093H,0D4H,00FH,04AH,0D0H
              DB 00FH,043H,0E4H,098H,086H,0E7H,091H,0F7H
              DB 01CH,04DH,0EEH,090H,004H,013H,0F0H,097H
              DB 07FH,01DH,0F4H,098H,086H,02BH,013H,049H
              DB 09AH,0BFH,0ABH,037H,001H,013H,085H,037H
              DB 003H,013H,086H,037H,0E2H,005H,043H,084H
              DB 0A1H,0F9H,097H,0F2H,033H,02FH,017H,049H
              DB 003H,097H,0D4H,00FH,04AH,0D0H,00FH,043H
              DB 008H,098H,086H,01DH,091H,0F7H,01CH,04DH
              DB 027H,01FH,04DH,0B0H,01BH,004H,01AH,029H
              DB 098H,081H,00AH,095H,0EDH,01FH,04DH,045H
              DB 0ABH,081H,03DH,0ABH,082H,006H,093H,005H
              DB 01DH,04DH,013H,01FH,04DH,0CCH,01BH,010H
              DB 013H,0FAH,093H,0EAH,03DH,01DH,04DH,088H
              DB 03BH,073H,005H,049H,00BH,097H,088H,037H
              DB 010H,010H,097H,033H,0A6H,01DH,0A8H,01DH
              DB 0F7H,093H,004H,016H,0E9H,0F2H,057H,0B1H
              DB 01DH,0EFH,0E3H,093H,004H,016H,0E9H,098H
              DB 0A8H,002H,097H,0B8H,00FH,064H,098H,0A2H
              DB 002H,097H,0A8H,00FH,064H,098H,0A3H,002H
              DB 097H,08DH,057H,0A7H,057H,0CFH,01DH,0EFH
              DB 0ABH,0BFH,080H,037H,0E0H,01AH,080H,033H
              DB 006H,098H,081H,00BH,091H,0C1H,0E0H,01DH
              DB 0F0H,093H,004H,016H,0E9H,098H,0A1H,002H
              DB 097H,0ACH,00FH,064H,099H,057H,0F0H,01DH
              DB 0EFH,098H,037H,060H,011H,098H,033H,0ABH
              DB 037H,0FBH,01DH,03DH,01DH,049H,0CBH,01DH
              DB 049H,0EEH,011H,049H,003H,01DH,02FH,006H
              DB 01DH,000H,011H,04DH,09AH,01DH,04DH,0EFH
              DB 090H,013H,08BH,005H,04DH,003H,094H,082H
              DB 006H,097H,082H,014H,00AH,097H,07EH,014H
              DB 094H,033H,010H,09DH,083H,013H,093H,001H
              DB 015H,0DEH,010H,043H,029H,02CH,01DH,01FH
              DB 090H,067H,013H,0E8H,097H,097H,036H,008H
              DB 01BH,06EH,01FH,049H,0DCH,01BH,010H,013H
              DB 010H,01DH,049H,010H,013H,0D4H,01BH,0A7H
              DB 017H,049H,004H,001H,093H,0C9H,0DEH,010H
              DB 048H,0ACH,01FH,04DH,0DEH,010H,043H,047H
              DB 090H,08CH,01FH,04DH,02BH,013H,049H,014H
              DB 094H,08BH,0F0H,09AH,083H,0BAH,0D0H,01FH
              DB 04DH,003H,093H,003H,011H,083H,033H,08BH
              DB 005H,04DH,083H,037H,060H,013H,0B6H,01FH
              DB 04DH,09AH,0BFH,0E9H,093H,040H,014H,004H
              DB 01EH,09AH,033H,0CAH,01FH,04DH,094H,01FH
              DB 04DH,08AH,033H,027H,004H,01EH,08BH,033H
              DB 09AH,037H,0CFH,0FAH,01EH,04DH,004H,01BH
              DB 010H,013H,084H,01FH,04DH,098H,0AAH,040H
              DB 097H,087H,0D0H,01FH,04DH,013H,01FH,04DH
              DB 0C8H,01BH,010H,013H,08FH,037H,040H,013H
              DB 08EH,037H,0C6H,08DH,037H,0C9H,001H,097H
              DB 087H,0CFH,0FBH,09AH,0EAH,08DH,0DFH,003H
              DB 01BH,097H,037H,0D9H,010H,043H,0D0H,01FH
              DB 04DH,036H,01FH,04DH,08FH,037H,0F0H,013H
              DB 055H,012H,04DH,09CH,01FH,04DH,0CCH,01BH
              DB 010H,013H,0FAH,01EH,04DH,0C4H,01BH,00FH
              DB 013H,09CH,01FH,04DH,044H,01BH,005H,013H
              DB 0FAH,01EH,04DH,024H,01BH,005H,013H,0D0H
              DB 01FH,04DH,036H,01FH,04DH,08FH,037H,0C3H
              DB 013H,055H,012H,04DH,010H,01DH,049H,0DCH
              DB 01BH,010H,013H,0D1H,00FH,049H,0C7H,00FH
              DB 049H,0D4H,00FH,049H,08AH,010H,049H,0C4H
              DB 00FH,049H,0C6H,018H,049H,010H,013H,0DFH
              DB 01BH,092H,037H,002H,097H,095H,033H,006H
              DB 097H,001H,015H,0DEH,010H,043H,0CBH,01DH
              DB 04DH,048H,013H,049H,06DH,013H,022H,097H
              DB 022H,014H,029H,097H,020H,014H,030H,097H
              DB 018H,014H,02BH,097H,016H,014H,02CH,097H
              DB 014H,014H,094H,033H,016H,097H,001H,015H
              DB 0DEH,010H,043H,022H,097H,012H,014H,094H
              DB 033H,023H,093H,053H,014H,093H,033H,09AH
              DB 01DH,04DH,0B7H,01DH,082H,005H,049H,003H
              DB 093H,001H,015H,0DEH,010H,043H,001H,013H
              DB 04DH,029H,082H,0A9H,002H,093H,012H,014H
              DB 006H,090H,082H,0ABH,004H,093H,013H,014H
              DB 00EH,097H,0D6H,010H,043H,0E6H,01DH,004H
              DB 01BH,0DBH,01DH,08EH,033H,0DFH,01DH,08DH
              DB 033H,011H,013H,04DH,0F5H,01DH,005H,01BH
              DB 004H,0FAH,093H,0EAH,0EEH,01DH,0CFH,004H
              DB 0F6H,093H,005H,016H,0E9H,093H,057H,03DH
              DB 01DH,04DH,0EFH,0CBH,01DH,049H,029H,090H
              DB 09CH,01DH,07FH,005H,049H,05CH,012H,04DH
              DB 094H,0ABH,0DFH,014H,049H,098H,01BH,005H
              DB 013H,013H,01DH,08EH,033H,017H,01DH,08DH
              DB 033H,011H,013H,04DH,0F7H,095H,005H,016H
              DB 0E9H,023H,01DH,08DH,053H,0EFH,0E4H,01EH
              DB 04DH,004H,01BH,0FAH,01EH,04DH,09CH,01BH
              DB 005H,013H,04AH,093H,004H,015H,0DEH,010H
              DB 043H,03BH,01DH,012H,013H,03FH,01DH,0B0H
              DB 013H,043H,01DH,021H,013H,047H,01DH,08EH
              DB 033H,04BH,01DH,025H,013H,04FH,01DH,011H
              DB 013H,002H,093H,08DH,033H,010H,01DH,04DH
              DB 0D6H,01BH,010H,013H,05EH,01DH,07EH,013H
              DB 062H,01DH,03FH,013H,05FH,090H,064H,093H
              DB 001H,015H,060H,093H,002H,015H,0DEH,010H
              DB 043H,001H,013H,04DH,092H,037H,0DDH,010H
              DB 043H,004H,0A0H,000H,0A0H,065H,01EH,04DH
              DB 082H,0AAH,002H,09AH,0C8H,0D5H,010H,043H
              DB 000H,011H,04DH,02EH,08CH,037H,004H,013H
              DB 0EFH,01DH,029H,004H,0F7H,093H,0EAH,07FH
              DB 0DFH,0EAH,037H,07FH,05CH,0EAH,03CH,076H
              DB 01BH,004H,087H,03BH,0AFH,017H,049H,099H
              DB 013H,005H,093H,0FEH,010H,04BH,087H,03FH
              DB 000H,055H,000H,000H,000H,000H,0F3H,017H
              DB 049H,017H,01FH,04DH,008H,0AFH,02BH,013H
              DB 049H,008H,0AFH,0B4H,017H,049H,008H,0AFH
              DB 05EH,015H,050H,0E2H,00EH,002H,088H,085H
              DB 008H,0F0H,000H,00DH,000H,000H,010H,003H
              DB 005H,011H,000H,000H,000H,000H,000H,049H
              DB 000H,000H,000H,000H,000H,040H,0FFH,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
              DB 000H,000H,000H,000H,000H,000H,000H,000H
;
ATR           DB   03FH,0FAH,011H,025H,005H,000H,001H,0B0H
              DB   002H,03BH,036H,04DH,059H,002H,081H,080H
;
INSTABLE      DB   70H
              DB   72H
              DB   74H
              DB   76H
              DB   78H
              DB   7AH
              DB   7CH
              DB   7EH
              DB   80H
              DB   82H
;
EPROMTAB1     DB 011H,01FH,011H,011H,010H,011H,011H,011H
              DB 051H,097H,011H,011H,010H,011H,011H,011H
              DB 000H,011H,011H,011H,011H,011H,011H,011H
              DB 011H,011H,011H,011H,011H,011H,011H,011H
              DB 000H,011H,011H,011H,011H,011H,011H,011H
              DB 011H,011H,011H,011H,011H,011H,011H,011H
              DB 000H,011H,011H,011H,011H,011H,011H,011H
              DB 011H,011H,011H,011H,011H,011H,011H,011H
              DB 000H,011H,011H,011H,011H,011H,011H,011H
              DB 011H,011H,011H,011H,011H,011H,011H,011H
              DB 000H,011H,011H,011H,011H,011H,011H,011H
              DB 011H,011H,011H,011H,011H,011H,011H,011H
              DB 000H,011H,011H,011H,011H,011H,011H,011H
              DB 011H,011H,011H,011H,011H,011H,011H,011H
              DB 000H,011H,011H,011H,011H,011H,011H,011H
              DB 011H,016H,011H,011H,011H,011H,011H,011H
              DB 000H,043H,011H,011H,011H,011H,011H,011H
              DB 011H,011H,011H,011H,011H,011H,011H,011H
              DB 000H,011H,011H,011H,011H,011H,011H,011H
              DB 011H,011H,011H,011H,011H,011H,011H,011H
              DB 000H,011H,011H,011H,011H,011H,011H,011H
              DB 011H,011H,04AH,011H,011H,011H,011H,011H
              DB 000H,011H,011H,011H,011H,011H,011H,011H
              DB 011H,011H,011H,011H,011H,011H,011H,011H
              DB 000H,011H,011H,011H,011H,011H,011H,011H
              DB 011H,011H,011H,011H,011H,011H,011H,011H
              DB 000H,011H,011H,011H,011H,011H,011H,011H
              DB 011H,011H,011H,011H,011H,011H,011H,011H
              DB 000H,011H,011H,011H,011H,011H,011H,011H
              DB 011H,011H,011H,011H,011H,011H,011H,011H
              DB 000H,011H,011H,011H,011H,011H,011H,011H
              DB 011H,011H,007H,0D9H,011H,011H,011H,011H
;
EPROMTAB2     DB 091H,061H,09DH,053H,0B3H,027H,0D5H,0D9H
              DB 00FH,059H,0A6H,06FH,073H,0FBH,099H,04CH
              DB 0FBH,045H,054H,08EH,020H,05FH,0B3H,0B1H
              DB 038H,0D0H,06BH,0A7H,040H,039H,0EDH,02AH
              DB 0DAH,043H,08DH,051H,092H,0D6H,0E3H,061H
              DB 065H,08CH,071H,0E6H,084H,065H,087H,003H
              DB 055H,0BCH,064H,007H,0BBH,079H,09EH,040H
              DB 097H,089H,0C4H,014H,08FH,08BH,041H,04DH
;
EPROMTAB3     DB 000H,000H,000H,000H,010H,06EH,01CH,0BDH
              DB 0FEH,044H,0EBH,079H,0F3H,0ABH,05DH,023H
              DB 0B3H,020H,0D2H,0E7H,0FCH,000H,003H,06FH
              DB 0D8H,0B7H,0F7H,0F3H,055H,072H,047H,013H
              DB 07BH,00CH,008H,001H,08AH,02CH,070H,056H
              DB 00AH,085H,018H,014H,043H,0C9H,046H,064H
              DB 06CH,09AH,099H,059H,00AH,06CH,040H,0D5H
              DB 017H,0B3H,02CH,069H,041H,0E8H,0E7H,00EH
;
EPROMTAB4     DB 048H,09BH,04DH,0A6H,0F9H,0D9H,0DFH,06EH
              DB 0ACH,084H,0FAH,08BH,02EH,0B6H,076H,019H
              DB 0C1H,0B0H,0A3H,0BBH,00CH,0FDH,070H,072H
              DB 0CAH,055H,0EFH,0A0H,07FH,0BFH,059H,0ADH
              DB 0D9H,045H,008H,0DBH,07CH,0F9H,056H,0F7H
              DB 058H,018H,022H,054H,038H,0CDH,03DH,094H
              DB 009H,0E6H,08EH,00DH,09AH,086H,0FCH,01CH
              DB 0A0H,019H,08FH,0BCH,0FDH,08DH,0D1H,057H
              DB 056H,0F2H,0B6H,04FH,0C9H,0BDH,02AH,0B3H
              DB 09DH,081H,05DH,0E0H,005H,0B5H,0B9H,026H
              DB 067H,03CH,065H,0A0H,0BAH,039H,0C7H,0AFH
              DB 033H,024H,047H,0A6H,020H,01EH,014H,06FH
              DB 065H,0E7H,071H,01AH,0B4H,088H,0D7H,076H
              DB 028H,0D0H,04CH,06EH,086H,08CH,0C8H,043H
              DB 0A9H,0ECH,060H,042H,005H,0F2H,03DH,01CH
              DB 06CH,0BCH,0AFH,0C3H,02BH,0B5H,0DCH,090H
;
EPROMTAB5     DB   0D8H
              DB   'ICARD  V2.02'
              DB   ' (C)',39,'95 DSH '
;
SCANTEXT      DB   'SCANNING #00'
;
HEXTABLE      DB   '0123456789ABCDEF'
;
IDTABLE       DB   0CH                      ; MULTICHANNEL
              DB   02H                      ; THE MOVIECHANNEL
              DB   01H                      ; SKY MOVIES
              DB   06H                      ; SKY SPORTS
              DB   03H                      ; SKY MOVIES GOLD
              DB   08H                      ; ZEE TV (TV ASIA)
;
CHANNELS      DB   '.CODE ERROR.'           ; 00
              DB   'MULTICHANNEL'           ; 01
              DB   'MOVIECHANNEL'           ; 02
              DB   ' SKY MOVIES '           ; 03
              DB   ' SKY SPORTS '           ; 04
              DB   'MOVIES  GOLD'           ; 05
              DB   '   ZEE TV   '           ; 06
              DB   'JSTV  EUROPE'           ; 07
              DB   'ADULTCHANNEL'           ; 08
              DB   '  EUROTICA  '           ; 09
;
;
;
              END
;
;
;
;
